(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/forms'), require('@angular/router')) :
    typeof define === 'function' && define.amd ? define('svogv', ['exports', '@angular/core', '@angular/common', '@angular/forms', '@angular/router'], factory) :
    (factory((global.svogv = {}),global.ng.core,global.ng.common,global.ng.forms,global.ng.router));
}(this, (function (exports,core,common,forms,router) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * This decorator is for validation of mandatory fields.
     * The default message is 'The field {keyName} is required'.
     *
     * @param {?=} msg The error message shown in case of error. A default value is being provided if omitted.
     *
     * @return {?}
     */
    function Required(msg) {
        // the original decorator
        /**
         * @param {?} target
         * @param {?} property
         * @return {?}
         */
        function requiredInternal(target, property) {
            requiredInternalSetup(target, property.toString(), msg);
        }
        // return the decorator
        return requiredInternal;
    }
    /**
     * @param {?} target
     * @param {?} key
     * @param {?=} msg
     * @return {?}
     */
    function requiredInternalSetup(target, key, msg) {
        Object.defineProperty(target, "__isRequired__" + key, {
            get: ( /**
             * @return {?}
             */function () { return true; }),
            enumerable: false,
            configurable: false
        });
        Object.defineProperty(target, "__errRequired__" + key, {
            value: msg || "The field " + key + " is required",
            enumerable: false,
            configurable: false
        });
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * The maxlength decorator assures that a string field contains not more than a number of characters.
     *
     * @param {?} len
     * @param {?=} msg
     * @return {?}
     */
    function MaxLength(len, msg) {
        // the original decorator
        /**
         * @param {?} target
         * @param {?} property
         * @return {?}
         */
        function maxLengthInternal(target, property) {
            maxLengthInternalSetup(target, property.toString(), len, msg);
        }
        // return the decorator
        return maxLengthInternal;
    }
    /**
     * @param {?} target
     * @param {?} key
     * @param {?} len
     * @param {?=} msg
     * @return {?}
     */
    function maxLengthInternalSetup(target, key, len, msg) {
        // create a helper property to transport a meta data value
        Object.defineProperty(target, "__hasMaxLength__" + key, {
            value: len,
            enumerable: false,
            configurable: false
        });
        Object.defineProperty(target, "__errMaxLength__" + key, {
            value: msg || "The field " + key + " has max length of " + len + " characters",
            enumerable: false,
            configurable: false
        });
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * The minlength decorator assures that a string field contains at least a number of characters.
     *
     * @param {?} len
     * @param {?=} msg
     * @return {?}
     */
    function MinLength(len, msg) {
        // the original decorator
        /**
         * @param {?} target
         * @param {?} property
         * @return {?}
         */
        function minLengthInternal(target, property) {
            minLengthInternalSetup(target, property.toString(), len, msg);
        }
        // return the decorator
        return minLengthInternal;
    }
    /**
     * @param {?} target
     * @param {?} key
     * @param {?} len
     * @param {?=} msg
     * @return {?}
     */
    function minLengthInternalSetup(target, key, len, msg) {
        // create a helper property to transport a meta data value
        Object.defineProperty(target, "__hasMinLength__" + key, {
            value: len,
            enumerable: false,
            configurable: false
        });
        Object.defineProperty(target, "__errMinLength__" + key, {
            value: msg || "The field " + key + " needs at least " + len + " characters",
            enumerable: false,
            configurable: false
        });
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * The decorator that assures that a string field contains at least a number of characters and a minimum number, too.
     * The default message is 'The field {fieldname} needs at least {minlength} characters'.
     *
     * @param {?} min
     * @param {?} max
     * @param {?=} msg
     * @return {?}
     */
    function StringLength(min, max, msg) {
        // the original decorator
        /**
         * @param {?} target
         * @param {?} property
         * @return {?}
         */
        function stringLengthInternal(target, property) {
            stringLengthInternalSetup(target, property.toString(), min, max, msg);
        }
        // return the decorator
        return stringLengthInternal;
    }
    /**
     * @param {?} target
     * @param {?} key
     * @param {?} min
     * @param {?} max
     * @param {?=} msg
     * @return {?}
     */
    function stringLengthInternalSetup(target, key, min, max, msg) {
        // create a helper property to transport a meta data value
        Object.defineProperty(target, "__hasMaxLength__" + key, {
            value: max,
            enumerable: false,
            configurable: false
        });
        Object.defineProperty(target, "__errMaxLength__" + key, {
            value: msg || "The field " + key + " has max length of " + max + " characters",
            enumerable: false,
            configurable: false
        });
        // create a helper property to transport a meta data value
        Object.defineProperty(target, "__hasMinLength__" + key, {
            value: min,
            enumerable: false,
            configurable: false
        });
        Object.defineProperty(target, "__errMinLength__" + key, {
            value: msg || "The field " + key + " needs at least " + min + " characters",
            enumerable: false,
            configurable: false
        });
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * The decorator assures that a string field fullfilles a regular expression pattern.
     *
     * @param {?} pattern
     * @param {?=} msg
     * @return {?}
     */
    function Pattern(pattern, msg) {
        // the original decorator
        /**
         * @param {?} target
         * @param {?} property
         * @return {?}
         */
        function patternInternal(target, property) {
            patternInternalSetup(target, property.toString(), pattern, msg);
        }
        // return the decorator
        return patternInternal;
    }
    /**
     * @param {?} target
     * @param {?} key
     * @param {?} reg
     * @param {?=} msg
     * @return {?}
     */
    function patternInternalSetup(target, key, reg, msg) {
        // create a helper property to transport a meta data value
        Object.defineProperty(target, "__hasPattern__" + key, {
            value: reg,
            enumerable: false,
            configurable: false
        });
        Object.defineProperty(target, "__errPattern__" + key, {
            value: msg || "The field " + key + " must fullfill the pattern " + reg,
            enumerable: false,
            configurable: false
        });
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Validates a field against an email pattern.
     * Based on "pattern", so in form one must use hasError('pattern') to get validation results.
     *
     * @param {?=} msg
     * @return {?}
     */
    function Email(msg) {
        // the original decorator
        /**
         * @param {?} target
         * @param {?} property
         * @return {?}
         */
        function emailInternal(target, property) {
            emailInternalSetup(target, property.toString(), msg);
        }
        // return the decorator
        return emailInternal;
    }
    /**
     * @param {?} target
     * @param {?} key
     * @param {?=} msg
     * @return {?}
     */
    function emailInternalSetup(target, key, msg) {
        // tslint:disable-next-line:max-line-length
        /** @type {?} */
        var pattern = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
        // create a helper property to transport a meta data value
        Object.defineProperty(target, "__hasPattern__" + key, {
            value: pattern,
            enumerable: false,
            configurable: false
        });
        Object.defineProperty(target, "__errPattern__" + key, {
            value: msg || "The field " + key + " must contain a valid e-mail address.",
            enumerable: false,
            configurable: false
        });
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Validates a field against an range. Applies to numerical values or dates.
     *
     * The range's values are included in the valid range.
     *
     * @param {?} from  The minimum value (included) as number or Date
     * @param {?} to    The maximum value (included) as number or Date
     * @param {?=} msg   A custom message. If not provided "The field [field] does not fall into the range from [from] to [to]"
     *              will be generated, while [field] is the propertie's name.
     * @return {?}
     */
    function Range(from, to, msg) {
        // the original decorator
        /**
         * @param {?} target
         * @param {?} property
         * @return {?}
         */
        function rangeInternal(target, property) {
            rangeInternalSetup(target, property.toString(), from, to, msg);
        }
        // return the decorator
        return rangeInternal;
    }
    /**
     * @param {?} target
     * @param {?} key
     * @param {?} from
     * @param {?} to
     * @param {?=} msg
     * @return {?}
     */
    function rangeInternalSetup(target, key, from, to, msg) {
        // property value
        // create a helper property to transport a meta data value
        Object.defineProperty(target, "__hasRangeFrom__" + key, {
            value: from,
            enumerable: false,
            configurable: false
        });
        Object.defineProperty(target, "__hasRangeTo__" + key, {
            value: to,
            enumerable: false,
            configurable: false
        });
        Object.defineProperty(target, "__errRange__" + key, {
            value: msg
                || "The field " + key + " does not fall into the range from " + from + " to " + to,
            enumerable: false,
            configurable: false
        });
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * The compare decorator compares two field's values and
     * shows an error message on the decorated field. The other field (compared to) does
     * not has a decorator nor receives a message.
     *
     * @param {?} withProperty
     * @param {?=} msg
     * @return {?}
     */
    function Compare(withProperty, msg) {
        // the original decorator
        /**
         * @param {?} target
         * @param {?} property
         * @return {?}
         */
        function compareInternal(target, property) {
            compareInternalSetup(target, property.toString(), withProperty, msg);
        }
        // return the decorator
        return compareInternal;
    }
    /**
     * @param {?} target
     * @param {?} key
     * @param {?} withProperty
     * @param {?=} msg
     * @return {?}
     */
    function compareInternalSetup(target, key, withProperty, msg) {
        // create a helper property to transport a meta data value
        Object.defineProperty(target, "__hasCompareProperty__" + key, {
            value: true,
            enumerable: false,
            configurable: false
        });
        Object.defineProperty(target, "__withCompare__" + key, {
            value: withProperty,
            enumerable: false,
            configurable: false
        });
        Object.defineProperty(target, "__errCompareProperty__" + key, {
            value: msg
                || "The field " + key + " must have the same value as field " + withProperty,
            enumerable: false,
            configurable: false
        });
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * The Display decorator.
     *
     * This decorator can be used on fields. It's being used to create label in forms and headers in the grid.
     * Additional parameters are provided to refine forms further.
     *
     * @param {?} name          The Name or Label that appears in forms or as header in grids.
     * @param {?=} order         If one uses AcAutoForm to create a whole form from a model, this controls the element's order.
     * @param {?=} description   A tooltip that can be used optionally.
     * @return {?}
     */
    function Display(name, order, description) {
        if (order === void 0) {
            order = 0;
        }
        // the original decorator
        /**
         * @param {?} target
         * @param {?} property
         * @return {?}
         */
        function displayInternal(target, property) {
            displayInternalSetup(target, property.toString(), name, order, description);
        }
        // return the decorator
        return displayInternal;
    }
    /**
     * @param {?} target
     * @param {?} key
     * @param {?} name
     * @param {?} order
     * @param {?} description
     * @return {?}
     */
    function displayInternalSetup(target, key, name, order, description) {
        order = parseInt(order.toString(), 10);
        // create a helper property to transport a meta data value
        Object.defineProperty(target, "__displayName__" + key, {
            value: name,
            enumerable: false,
            configurable: false
        });
        Object.defineProperty(target, "__displayOrder__" + key, {
            value: order,
            enumerable: false,
            configurable: false
        });
        Object.defineProperty(target, "__displayDesc__" + key, {
            value: description,
            enumerable: false,
            configurable: false
        });
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * The UiHint decorator.
     *
     *
     * @param {?} uiHint
     * @return {?}
     */
    function UiHint(uiHint) {
        // the original decorator
        /**
         * @param {?} target
         * @param {?} property
         * @return {?}
         */
        function uiHintInternal(target, property) {
            uiHintInternalSetup(target, property.toString(), uiHint);
        }
        // return the decorator
        return uiHintInternal;
    }
    /**
     * @param {?} target
     * @param {?} key
     * @param {?} uiHint
     * @return {?}
     */
    function uiHintInternalSetup(target, key, uiHint) {
        // create a helper property to transport a meta data value
        Object.defineProperty(target, "__uiHint__" + key, {
            value: uiHint,
            enumerable: false,
            configurable: false
        });
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * The DisplayGroup decorator. Groups fields in auto forms.
     * Just define a name (that appears as the group's name) and
     * put the very same name on all members of the group.
     *
     * @param {?} name          The Name or Label that appears in forms as the groups legend.
     * @param {?=} order         If one uses AcAutoForm to create a whole form from a model, this controls the groups order.
     * @param {?=} description   A tooltip that can be used optionally.
     * @return {?}
     */
    function DisplayGroup(name, order, description) {
        if (order === void 0) {
            order = 0;
        }
        // the original decorator
        /**
         * @param {?} target
         * @param {?} property
         * @return {?}
         */
        function displayGroupInternal(target, property) {
            displayGroupInternalSetup(target, property.toString(), name, order, description);
        }
        // return the decorator
        return displayGroupInternal;
    }
    /**
     * @param {?} target
     * @param {?} key
     * @param {?} name
     * @param {?} order
     * @param {?} description
     * @return {?}
     */
    function displayGroupInternalSetup(target, key, name, order, description) {
        order = parseInt(order.toString(), 10);
        // create a helper property to transport a meta data value
        Object.defineProperty(target, "__isGrouped__" + key, {
            value: true,
            enumerable: false,
            configurable: false
        });
        Object.defineProperty(target, "__groupName__" + key, {
            value: name,
            enumerable: false,
            configurable: false
        });
        Object.defineProperty(target, "__groupOrder__" + key, {
            value: order,
            enumerable: false,
            configurable: false
        });
        Object.defineProperty(target, "__groupDesc__" + key, {
            value: description,
            enumerable: false,
            configurable: false
        });
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * The Placeholder decorator.
     *
     * The placeholder adds the given text as a watermark to any input fields.
     * There is no function in DataGrid.
     *
     * @param {?} name          The Name that appears in form fields as a watermark.
     * @return {?}
     */
    function Placeholder(name) {
        // the original decorator
        /**
         * @param {?} target
         * @param {?} property
         * @return {?}
         */
        function placeholderInternal(target, property) {
            placeholderInternalSetup(target, property.toString(), name);
        }
        // return the decorator
        return placeholderInternal;
    }
    /**
     * @param {?} target
     * @param {?} key
     * @param {?} name
     * @return {?}
     */
    function placeholderInternalSetup(target, key, name) {
        // create a helper property to transport a meta data value
        Object.defineProperty(target, "__watermark__" + key, {
            value: name,
            enumerable: false,
            configurable: false
        });
        Object.defineProperty(target, "__hasWatermark__" + key, {
            value: true,
            enumerable: false,
            configurable: false
        });
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * The Template decorator.
     *
     * One can define the way a property gets rendered.
     * Currently supported:
     *  - TextArea
     *  - Calendar
     *  - Range
     *  - Number
     *  - Text
     *
     * The Calendar creates Date-fielsd. However, in casde of a datatype Date the date field will be created anyway.
     *
     * @param {?} template        The Name that appears in form fields as a watermark.
     * @param {?=} params          Depending of template some additional values as a dictionary.
     * @return {?}
     */
    function TemplateHint(template, params) {
        // the original decorator
        /**
         * @param {?} target
         * @param {?} name
         * @return {?}
         */
        function templateHintInternal(target, name) {
            templateHintInternalSetup(target, name, template, params);
        }
        // return the decorator
        return templateHintInternal;
    }
    /**
     * @param {?} target
     * @param {?} key
     * @param {?} template
     * @param {?=} params
     * @return {?}
     */
    function templateHintInternalSetup(target, key, template, params) {
        // create a helper property to transport a meta data value
        Object.defineProperty(target, "__templatehint__" + key, {
            value: template,
            enumerable: false,
            configurable: false
        });
        if (params) {
            Object.defineProperty(target, "__templatehintParams__" + key, {
                value: params,
                enumerable: false,
                configurable: false
            });
        }
        Object.defineProperty(target, "__hasTemplateHint__" + key, {
            value: true,
            enumerable: false,
            configurable: false
        });
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * The Hidden decorator.
     *
     * The \@see `DataGrid` does not show columns for properties tagged with `\@Hidden()`.
     * Fields in forms that render automatically
     * using the \@see `AcEditor` component will render as <input type="hidden">.
     *
     * @param {?=} hide          Optional, default is true.
     * @return {?}
     */
    function Hidden(hide) {
        if (hide === void 0) {
            hide = true;
        }
        // the original decorator
        /**
         * @param {?} target
         * @param {?} property
         * @return {?}
         */
        function hiddenInternal(target, property) {
            hiddenInternalSetup(target, property.toString(), hide);
        }
        // return the decorator
        return hiddenInternal;
    }
    /**
     * @param {?} target
     * @param {?} key
     * @param {?} hide
     * @return {?}
     */
    function hiddenInternalSetup(target, key, hide) {
        // create a helper property to transport a meta data value
        Object.defineProperty(target, "__isHidden__" + key, {
            value: hide,
            enumerable: false,
            configurable: false
        });
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * The Sortable decorator.
     *
     * The \@see `DataGrid` does not sort columns for properties tagged with `\@Sortable(false)`.
     * The default is that all columsn are sortable. Either avoid this decorator or use `\@Sortable(true)`.
     * Additionally, if the decorator is provided, you can add a sort function callback as second parameter.
     *
     * @param {?} canSort       Suppress or allow sorting.
     * @param {?=} sortCallback  An optional callback that provides a sort instruction. If omitted, `Array.prototype.sort` is being used.
     * @return {?}
     */
    function Sortable(canSort, sortCallback) {
        // the original decorator
        /**
         * @param {?} target
         * @param {?} property
         * @return {?}
         */
        function sortableInternal(target, property) {
            sortableInternalSetup(target, property.toString(), canSort, sortCallback);
        }
        // return the decorator
        return sortableInternal;
    }
    /**
     * @param {?} target
     * @param {?} key
     * @param {?} canSort
     * @param {?} sortCallback
     * @return {?}
     */
    function sortableInternalSetup(target, key, canSort, sortCallback) {
        // create a helper property to transport a meta data value
        Object.defineProperty(target, "__isSortable__" + key, {
            value: canSort,
            enumerable: false,
            configurable: false
        });
        Object.defineProperty(target, "__sortCallback__" + key, {
            value: sortCallback,
            enumerable: false,
            configurable: false
        });
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * The Readonly decorator. The field is readonly in the form. It just renders grayed out
     * and handles the internals using default HTML5 techniques.
     *
     *
     * @param {?=} readonly      Optional, default is true.
     * @return {?}
     */
    function Readonly(readonly) {
        if (readonly === void 0) {
            readonly = true;
        }
        // the original decorator
        /**
         * @param {?} target
         * @param {?} property
         * @return {?}
         */
        function readonlyInternal(target, property) {
            readonlyInternalSetup(target, property.toString(), readonly);
        }
        // return the decorator
        return readonlyInternal;
    }
    /**
     * @param {?} target
     * @param {?} key
     * @param {?} readonly
     * @return {?}
     */
    function readonlyInternalSetup(target, key, readonly) {
        // create a helper property to transport a meta data value
        Object.defineProperty(target, "__isReadonly__" + key, {
            value: readonly,
            enumerable: false,
            configurable: false
        });
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * The Format decorator. Provide the name of a Pipe that's being used by the
     * dynamic pipe formatter. Hence, the form does not need to apply forms manually.
     * The reason is that you may create forms automatically and hence can't write
     * actual Pipes somewhere. This applies especially if you create a table and loop
     * through properties.
     *
     * @param {?} pipe
     * @param {?=} pipeParams
     * @return {?}
     */
    function FormatPipe(pipe, pipeParams) {
        if (pipeParams === void 0) {
            pipeParams = null;
        }
        // the original decorator
        /**
         * @param {?} target
         * @param {?} property
         * @return {?}
         */
        function formatInternal(target, property) {
            formatInternalSetup(target, property.toString(), pipe, pipeParams);
        }
        // return the decorator
        return formatInternal;
    }
    /**
     * @param {?} target
     * @param {?} key
     * @param {?} pipe
     * @param {?=} pipeParams
     * @return {?}
     */
    function formatInternalSetup(target, key, pipe, pipeParams) {
        if (pipeParams === void 0) {
            pipeParams = null;
        }
        // create a helper property to transport a meta data value
        Object.defineProperty(target, "__uipipe__" + key, {
            value: pipe,
            enumerable: false,
            configurable: false
        });
        if (pipeParams && pipeParams.length) {
            Object.defineProperty(target, "__pipeparams__" + key, {
                value: pipeParams,
                enumerable: false,
                configurable: false
            });
        }
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A custom validator to valdiate a range of numbers or dates. This is internally to support the infarstructure
     * and not intended to being used by custom code.
     *
     * @param {?} f
     * @param {?} t
     * @return {?}
     */
    function validateRange(f, t) {
        return ( /**
         * @param {?} c
         * @return {?}
         */function (c) {
            if ((Number(f) || Number(t)) && Number(c.value)) {
                /** @type {?} */
                var fr = Number(f);
                /** @type {?} */
                var to = Number(t);
                /** @type {?} */
                var v = Number(c.value);
                return (!fr || v >= fr) && (!to || v <= to)
                    ? null
                    : {
                        range: {
                            valid: false
                        }
                    };
            }
            if ((Date.parse(f.toString()) || Date.parse(t.toString())) && Date.parse(c.value)) {
                /** @type {?} */
                var fr = Date.parse(f.toString());
                /** @type {?} */
                var to = Date.parse(t.toString());
                /** @type {?} */
                var v = Date.parse(c.value);
                return (!fr || v >= fr) && (!to || v <= to)
                    ? null
                    : {
                        range: {
                            valid: false
                        }
                    };
            }
        });
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A custom validator to compare two fields. This is internally to support the infarstructure
     * and not intended to being used by custom code.
     *
     * @param {?} p The field's name
     *
     * @return {?}
     */
    function validateCompare(p) {
        /** @type {?} */
        var changeEventWasAdded = false;
        return ( /**
         * @param {?} c
         * @return {?}
         */function (c) {
            /** @type {?} */
            var form = ( /** @type {?} */(c.root));
            if (form && form.controls && !changeEventWasAdded) {
                form.controls[p].valueChanges.subscribe(( /**
                 * @return {?}
                 */function () {
                    // trigger validation for particular element
                    c.updateValueAndValidity();
                }));
                changeEventWasAdded = true;
            }
            if (c.value) {
                // compare the current value with the referenced control's value
                return !c.value || c.value === (( /** @type {?} */(c.root)))['controls'][p].value
                    ? null
                    : {
                        compare: {
                            valid: false
                        }
                    };
            }
        });
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * The form validator service creates a FormGroup object from a viewmodel. If the viewmodel
     * has been decorated with validation decorators the validators are created accordingly.
     *
     * The simplest way is creating a class with properties and add decorators, such as
     * @see StringLength. The service will than create a \@see FormGroup that contains a validator
     * of type \@see StringLength for the property the decorator is written on.
     *
     * The decorators provide properties for additional information, such as a custom error message.
     *
     */
    var FormValidatorService = /** @class */ (function () {
        function FormValidatorService(fb) {
            this.fb = fb;
        }
        /**
         * @param {?} target
         * @return {?}
         */
        FormValidatorService.prototype.build = /**
         * @param {?} target
         * @return {?}
         */
            function (target) {
                /** @type {?} */
                var valGroup = {};
                /** @type {?} */
                var errGroup = {};
                /** @type {?} */
                var form;
                /** @type {?} */
                var targetInstance;
                if (target) {
                    // the cast is just to suppress TS errors and shows it's intentionally
                    try {
                        targetInstance = new target();
                    }
                    catch (ex) {
                        console.error('Invalid viewmodel for FormValidatorService');
                    }
                }
                if (targetInstance) {
                    // tslint:disable-next-line:forin
                    for (var propName in targetInstance) {
                        /** @type {?} */
                        var validators = new Array();
                        /** @type {?} */
                        var errmsgs = new Object();
                        /** @type {?} */
                        var isRequired = "__isRequired__" + propName in target.prototype;
                        if (isRequired) {
                            (( /** @type {?} */(errmsgs)))['required'] = target.prototype["__errRequired__" + propName];
                            validators.push(forms.Validators.required);
                        }
                        /** @type {?} */
                        var hasMaxLength = "__hasMaxLength__" + propName in target.prototype;
                        if (hasMaxLength) {
                            (( /** @type {?} */(errmsgs)))['maxlength'] = target.prototype["__errMaxLength__" + propName];
                            /** @type {?} */
                            var maxLength = parseInt(target.prototype["__hasMaxLength__" + propName], 10);
                            validators.push(forms.Validators.maxLength(maxLength));
                        }
                        /** @type {?} */
                        var hasMinLength = "__hasMinLength__" + propName in target.prototype;
                        if (hasMinLength) {
                            (( /** @type {?} */(errmsgs)))['minlength'] = target.prototype["__errMinLength__" + propName];
                            /** @type {?} */
                            var minLength = parseInt(target.prototype["__hasMinLength__" + propName], 10);
                            validators.push(forms.Validators.minLength(minLength));
                        }
                        /** @type {?} */
                        var hasPattern = "__hasPattern__" + propName in target.prototype;
                        if (hasPattern) {
                            (( /** @type {?} */(errmsgs)))['pattern'] = target.prototype["__errPattern__" + propName];
                            /** @type {?} */
                            var pattern = new RegExp(target.prototype["__hasPattern__" + propName]);
                            validators.push(forms.Validators.pattern(pattern));
                        }
                        /** @type {?} */
                        var hasRangeFrom = "__hasRangeFrom__" + propName in target.prototype;
                        /** @type {?} */
                        var hasRangeTo = "__hasRangeTo__" + propName in target.prototype;
                        if (hasRangeFrom || hasRangeTo) {
                            (( /** @type {?} */(errmsgs)))['range'] = target.prototype["__errRange__" + propName];
                            /** @type {?} */
                            var f = Number(target.prototype["__hasRangeFrom__" + propName]);
                            /** @type {?} */
                            var t = Number(target.prototype["__hasRangeTo__" + propName]);
                            if (!f && !t) {
                                // If NaN assume Date
                                f = Date.parse(f.toString());
                                t = Date.parse(t.toString());
                            }
                            validators.push(validateRange(f, t));
                        }
                        /** @type {?} */
                        var hasCompare = "__hasCompareProperty__" + propName in target.prototype;
                        if (hasCompare) {
                            (( /** @type {?} */(errmsgs)))['compare'] = target.prototype["__errCompareProperty__" + propName];
                            /** @type {?} */
                            var compare = target.prototype["__withCompare__" + propName];
                            validators.push(validateCompare(compare));
                        }
                        if (validators.length === 0) {
                            // even if there is no validator we need to add the property to the group
                            (( /** @type {?} */(valGroup)))[propName] = [target[propName]];
                        }
                        if (validators.length === 1) {
                            (( /** @type {?} */(valGroup)))[propName] = [target[propName] || '', validators[0]];
                        }
                        if (validators.length >= 1) {
                            (( /** @type {?} */(valGroup)))[propName] = [target[propName] || '', forms.Validators.compose(validators)];
                        }
                        (( /** @type {?} */(errGroup)))[propName] = errmsgs;
                    }
                    // create form group
                    form = this.fb.group(valGroup);
                    // forward the model to the editors for easy access to other decorators
                    // the cast is just to suppress TS errors and shows it's intentionally
                    (( /** @type {?} */(form)))['__editorModel__'] = targetInstance;
                    // register controls and add messages
                    // tslint:disable-next-line:forin
                    for (var propName in errGroup) {
                        /** @type {?} */
                        var ctrl = ( /** @type {?} */(form.controls[propName]));
                        if (!ctrl) {
                            continue; // control might not be in the form
                        }
                        (( /** @type {?} */(form.controls[propName])))['messages'] = (( /** @type {?} */(errGroup)))[propName];
                    }
                }
                // return FormGroup for immediate usage
                return form;
            };
        FormValidatorService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        FormValidatorService.ctorParameters = function () {
            return [
                { type: forms.FormBuilder, decorators: [{ type: core.Inject, args: [forms.FormBuilder,] }] }
            ];
        };
        return FormValidatorService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A JSON object can describe the form. That way you can create the form and their behavior on the server.
     *
     * The form's description is an array, where each element describes one field:
     *
     * ```
     * [
     *   "fieldname": {
     *       "display": {
     *          "name": string;
     *          "order": number;
     *          "description": string
     *       },
     *       "displaygroup": {
     *          "name": string;
     *          "order": number;
     *          "description": string
     *       },
     *       "format": {
     *          "pipeName": any;
     *          "pipeParams": any[]
     *       }
     *       // ...
     *    }
     * ]
     * ```
     *
     * The properties are the same as the decorators. \@see FormValidatorModel for the describing type.
     *
     */
    var FormValidatorFromJsonService = /** @class */ (function () {
        function FormValidatorFromJsonService(formValidatorService) {
            this.formValidatorService = formValidatorService;
        }
        /**
         * @param {?} json
         * @return {?}
         */
        FormValidatorFromJsonService.prototype.build = /**
         * @param {?} json
         * @return {?}
         */
            function (json) {
                /** @type {?} */
                var target = {};
                // convert json (indexed object ==> array ==> object properties)
                /** @type {?} */
                var fields = Object.keys(json);
                fields.forEach(( /**
                 * @param {?} field
                 * @return {?}
                 */function (field) {
                    /** @type {?} */
                    var types = Object.keys(json[field]);
                    types.forEach(( /**
                     * @param {?} type
                     * @return {?}
                     */function (type) {
                        switch (type) {
                            case 'display':
                                displayInternalSetup(target, field, (( /** @type {?} */(json)))[field][type]['name'], (( /** @type {?} */(json)))[field][type]['order'] ? +(( /** @type {?} */(field)))[type]['order'] : 0, (( /** @type {?} */(json)))[field][type]['description']);
                                break;
                            case 'displayGroup':
                                displayGroupInternalSetup(target, field, (( /** @type {?} */(json)))[field][type]['name'], (( /** @type {?} */(json)))[field][type]['order'] ? +(( /** @type {?} */(field)))[type]['order'] : 0, (( /** @type {?} */(json)))[field][type]['description']);
                                break;
                            case 'format':
                                formatInternalSetup(target, field, (( /** @type {?} */(json)))[field][type]['pipeName'], (( /** @type {?} */(json)))[field][type]['pipeParams']);
                                break;
                            case 'hidden':
                                hiddenInternalSetup(target, field, (( /** @type {?} */(json)))[field][type]['hidden'] || !!(( /** @type {?} */(field)))[type]['hidden']);
                                break;
                            case 'readonly':
                                readonlyInternalSetup(target, field, (( /** @type {?} */(json)))[field][type]['readonly'] || !!(( /** @type {?} */(field)))[type]['readonly']);
                                break;
                            case 'placeHolder':
                                placeholderInternalSetup(target, field, (( /** @type {?} */(json)))[field][type]['name']);
                                break;
                            case 'compare':
                                compareInternalSetup(target, field, (( /** @type {?} */(json)))[field][type]['fieldToCompare'], (( /** @type {?} */(json)))[field][type]['msg']);
                                break;
                            case 'maxlength':
                                maxLengthInternalSetup(target, field, +(( /** @type {?} */(json)))[field][type]['max'], (( /** @type {?} */(json)))[field][type]['msg']);
                                break;
                            case 'minlength':
                                minLengthInternalSetup(target, field, +(( /** @type {?} */(json)))[field][type]['min'], (( /** @type {?} */(json)))[field][type]['msg']);
                                break;
                            case 'pattern':
                                patternInternalSetup(target, field, (( /** @type {?} */(json)))[field][type]['pattern'], (( /** @type {?} */(json)))[field][type]['msg']);
                                break;
                            case 'stringLength':
                                stringLengthInternalSetup(target, field, +(( /** @type {?} */(json)))[field][type]['min'], +(( /** @type {?} */(json)))[field][type]['max'], (( /** @type {?} */(json)))[field][type]['msg']);
                                break;
                            case 'email':
                                emailInternalSetup(target, field, (( /** @type {?} */(json)))[field][type]['msg']);
                                break;
                            case 'range':
                                rangeInternalSetup(target, field, (( /** @type {?} */(json)))[field][type]['from'], (( /** @type {?} */(json)))[field][type]['to'], (( /** @type {?} */(json)))[field][type]['msg']);
                                break;
                            case 'required':
                                requiredInternalSetup(target, field, (( /** @type {?} */(json)))[field][type]['msg']);
                                break;
                        }
                    }));
                }));
                return this.formValidatorService.build(target);
            };
        FormValidatorFromJsonService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        FormValidatorFromJsonService.ctorParameters = function () {
            return [
                { type: FormValidatorService }
            ];
        };
        return FormValidatorFromJsonService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * The pagination component creates a few buttons to navigate a grid. The underlaying model
     * is going to handle the date on the client. The pagination does not support a server backend,
     * all relevant data must be loaded first.
     */
    var DataGridPaginationComponent = /** @class */ (function () {
        function DataGridPaginationComponent() {
            /**
             * An event fired once the user has changed the page by clicking a button.
             */
            this.pageNumberChanged = new core.EventEmitter();
            this.currentPageNumber = 1;
        }
        /**
         * @return {?}
         */
        DataGridPaginationComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                this.setCurrentPage(1);
            };
        /**
         * @param {?} changes
         * @return {?}
         */
        DataGridPaginationComponent.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
            function (changes) {
                var _this = this;
                if (changes['maxPageIndex']) {
                    /** @type {?} */
                    var change = changes['maxPageIndex'];
                    if (this.currentPageNumber > change.currentValue) {
                        // throws ExpressionChangedAfterItHasBeenCheckedException
                        // if there's no setTimeout.
                        // no need to add setTimeout if ngOnChanges
                        // is fired after changes made on root component.
                        setTimeout(( /**
                         * @return {?}
                         */function () { return _this.setCurrentPage(1); }), 1);
                    }
                }
            };
        /**
         * @param {?} pageNumber
         * @param {?=} event
         * @return {?}
         */
        DataGridPaginationComponent.prototype.setCurrentPage = /**
         * @param {?} pageNumber
         * @param {?=} event
         * @return {?}
         */
            function (pageNumber, event) {
                if (event) {
                    event.preventDefault();
                }
                if (pageNumber === 0 || pageNumber > this.maxPageIndex
                    || pageNumber === this.currentPageNumber) {
                    return;
                }
                this.pageNumberChanged.emit(pageNumber);
                this.currentPageNumber = pageNumber;
            };
        /**
         * @param {?} min
         * @param {?} max
         * @return {?}
         */
        DataGridPaginationComponent.prototype.range = /**
         * @param {?} min
         * @param {?} max
         * @return {?}
         */
            function (min, max) {
                /** @type {?} */
                var result = new Array();
                for (var i = min; i <= max; i++) {
                    result.push(i);
                }
                return result;
            };
        Object.defineProperty(DataGridPaginationComponent.prototype, "pageStartNumber", {
            get: /**
             * @return {?}
             */ function () {
                /** @type {?} */
                var startNumber = this.currentPageNumber <= 4
                    ? 1
                    : this.currentPageNumber >= this.maxPageIndex - 3
                        ? this.maxPageIndex - 6
                        : this.currentPageNumber - 3;
                return startNumber < 1 ? 1 : startNumber;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DataGridPaginationComponent.prototype, "pageEndNumber", {
            get: /**
             * @return {?}
             */ function () {
                /** @type {?} */
                var pageEnd = this.pageStartNumber + 6;
                return pageEnd > this.maxPageIndex ? this.maxPageIndex : pageEnd;
            },
            enumerable: true,
            configurable: true
        });
        DataGridPaginationComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ac-datagrid-pagination',
                        template: "<div>\n  <ul class=\"pagination float-right\" [ngClass]=\"{ 'pagination-sm': size == 'sm', 'pagination-lg': size == 'lg' }\">\n    <li [class.disabled]=\"currentPageNumber === 1 || !maxPageIndex\" class=\"page-item\">\n      <a href (click)=\"setCurrentPage(1, $event)\" aria-label=\"Previous\" class=\"page-link\">\n        <span aria-hidden=\"true\">\u00AB</span>\n      </a>\n    </li>\n    <li [class.disabled]=\"currentPageNumber === 1 || !maxPageIndex\" class=\"page-item\">\n      <a\n        href\n        aria-label=\"Previous\"\n        (click)=\"setCurrentPage(currentPageNumber - 1, $event)\"\n        class=\"page-link\">\n        <span aria-hidden=\"true\">\u2039</span>\n      </a>\n    </li>\n    <li\n      *ngFor=\"let index of range(pageStartNumber, pageEndNumber)\"\n      [class.active]=\"currentPageNumber === index\"\n      class=\"page-item\">\n      <a href (click)=\"setCurrentPage(index, $event)\" class=\"page-link\">\n        <span aria-hidden=\"true\">{{ index }}</span>\n      </a>\n    </li>\n    <li [class.disabled]=\"currentPageNumber === maxPageIndex || !maxPageIndex\">\n      <a class=\"page-link\"\n        href\n        (click)=\"setCurrentPage(currentPageNumber + 1, $event)\"\n        aria-label=\"Last\"\n      >\n        <span aria-hidden=\"true\">\u203A</span>\n      </a>\n    </li>\n    <li [class.disabled]=\"currentPageNumber === maxPageIndex || !maxPageIndex\" class=\"page-item\">\n      <a href (click)=\"setCurrentPage(maxPageIndex, $event)\" aria-label=\"Last\" class=\"page-link\">\n        <span aria-hidden=\"true\">\u00BB</span>\n      </a>\n    </li>\n  </ul>\n</div>\n",
                        styles: [""]
                    }] }
        ];
        DataGridPaginationComponent.propDecorators = {
            maxPageIndex: [{ type: core.Input }],
            pageNumberChanged: [{ type: core.Output }],
            size: [{ type: core.Input }]
        };
        return DataGridPaginationComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    Object.same = ( /**
     * @param {?} source
     * @param {?} target
     * @return {?}
     */function (source, target) {
        if (source === target) {
            return true;
        }
        if (!(source instanceof Object) || !(target instanceof Object)) {
            return false;
        }
        // if they are not strictly equal, they both need to be Objects
        for (var prop in source) {
            if (!source.hasOwnProperty(prop)) {
                continue;
            }
            if (source[prop] === undefined || source[prop] === null || source[prop] === '') {
                continue;
            }
            if (typeof source[prop] === 'object' && Object.same(source[prop], target[prop])) {
                continue;
            }
            if (typeof source[prop] === 'string' && target[prop].startsWith(source[prop])) {
                continue;
            }
            if (source[prop] === target[prop]) {
                continue;
            }
            return false;
        }
        return true;
    });
    Object.equals = ( /**
     * @param {?} x
     * @param {?} y
     * @return {?}
     */function (x, y) {
        if (x === y) {
            return true;
        }
        // if both x and y are null or undefined and exactly the same
        if (!(x instanceof Object) || !(y instanceof Object)) {
            return false;
        }
        // if they are not strictly equal, they both need to be Objects
        if (x.constructor !== y.constructor) {
            return false;
        }
        // they must have the exact same prototype chain, the closest we can do is
        // test there constructor.
        for (var p in x) {
            if (!x.hasOwnProperty(p)) {
                continue;
            }
            // other properties were tested using x.constructor === y.constructor
            if (!y.hasOwnProperty(p)) {
                return false;
            }
            // allows to compare x[ p ] and y[ p ] when set to undefined
            if (x[p] === y[p]) {
                continue;
            }
            // if they have the same strict value or identity then they are equal
            if (typeof (x[p]) !== 'object') {
                return false;
            }
            // Numbers, Strings, Functions, Booleans must be strictly equal
            if (!Object.equals(x[p], y[p])) {
                return false;
            }
            // Objects and Arrays must be tested recursively
        }
        for (var p in y) {
            if (y.hasOwnProperty(p) && !x.hasOwnProperty(p)) {
                return false;
            }
            // allows x[ p ] to be set to undefined
        }
        return true;
    });

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Describe a header field with name, tooltip and other properties.
     */
    var /**
     * Describe a header field with name, tooltip and other properties.
     */ DataGridHeaderModel = /** @class */ (function () {
        /**
         * The ctor
         * @param text: The text to display.
         * @param desc: A tooltip that is shown on mouseover (using the `title` attribute).
         * @param prop: The propertie's internal name.
         * @param hidden: optionally set a field as hidden and hence do not show in the grid.
         */
        function DataGridHeaderModel(text, desc, prop, hidden) {
            if (hidden === void 0) {
                hidden = false;
            }
            this.text = text;
            this.desc = desc;
            this.prop = prop;
            this.hidden = hidden;
            this.isSortable = true;
            this.templateHint = 'text';
        }
        return DataGridHeaderModel;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {number} */
    var Direction = {
        Ascending: 0,
        Descending: 1,
    };
    Direction[Direction.Ascending] = 'Ascending';
    Direction[Direction.Descending] = 'Descending';
    /**
     * The controlling class for Grid applications.
     *
     * This class takes an array of elements and handles:
     * - visible headers, managed by \@Hidden() decorator
     * - create header titles, managed by \@Display() decorator
     * - sorting
     * - filtering
     * - count total rows
     * - paging
     * @template T
     */
    var /**
     * The controlling class for Grid applications.
     *
     * This class takes an array of elements and handles:
     * - visible headers, managed by \@Hidden() decorator
     * - create header titles, managed by \@Display() decorator
     * - sorting
     * - filtering
     * - count total rows
     * - paging
     * @template T
     */ DataGridModel = /** @class */ (function () {
        function DataGridModel(items, type, pageSize) {
            if (pageSize === void 0) {
                pageSize = 10;
            }
            /**
             * The search value filters the rows. Provide the property name and the filter instruction. Search is pure client.
             */
            this.searchValue = {};
            this.currentPageIndex = 1;
            /**
             * Event fired if user clicks Edit button.
             */
            this.onEdit = new core.EventEmitter();
            /**
             * Event fired if user clicks Delete button.
             */
            this.onDelete = new core.EventEmitter();
            /**
             * Current sort direction per column.
             */
            this.sortDirection = {};
            this._items = items;
            this.pageSize = pageSize;
            /** @type {?} */
            var typeInstance = new type();
            if (typeInstance) {
                // make header from decorators, omit if null
                this.createHeadersForType(typeInstance);
            }
        }
        Object.defineProperty(DataGridModel.prototype, "totalRows", {
            get: /**
             * @return {?}
             */ function () {
                return this._items.length;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DataGridModel.prototype, "totalFilteredRows", {
            get: /**
             * @return {?}
             */ function () {
                return this.itemsFiltered ? this.itemsFiltered.length : 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DataGridModel.prototype, "currentRowStart", {
            get: /**
             * @private
             * @return {?}
             */ function () {
                return this.totalRows > this.pageSize ? this.startRow + 1 : this.totalRows === 0 ? 0 : 1;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DataGridModel.prototype, "currentRowEnd", {
            get: /**
             * @private
             * @return {?}
             */ function () {
                return this.startRow + this.pageSize < this.totalRows ? this.startRow + this.pageSize : this.totalRows;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DataGridModel.prototype, "startRow", {
            get: /**
             * @return {?}
             */ function () {
                if (this.currentPageIndex === 0) {
                    return 0;
                }
                return (this.currentPageIndex - 1) * this.pageSize;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DataGridModel.prototype, "maxPageIndex", {
            get: /**
             * @return {?}
             */ function () {
                /** @type {?} */
                var index = Math.ceil(this.totalFilteredRows / this.pageSize);
                return index;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DataGridModel.prototype, "items", {
            get: /**
             * @return {?}
             */ function () {
                return this._items;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */ function (value) {
                this._items = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DataGridModel.prototype, "itemsFiltered", {
            get: /**
             * @return {?}
             */ function () {
                var _this = this;
                // not actually a filter present
                if (!this.searchValue || (Object.keys(this.searchValue).length === 0 && this.searchValue.constructor === Object)) {
                    return this.items;
                }
                return this.items.filter(( /**
                 * @param {?} item
                 * @return {?}
                 */function (item) {
                    // tslint:disable-next-line:forin
                    for (var s in _this.searchValue) {
                        /** @type {?} */
                        var pattern = new RegExp(_this.searchValue[s]);
                        if (pattern.test(item[s])) {
                            return true;
                        }
                    }
                    return false;
                }));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DataGridModel.prototype, "itemsOnCurrentPage", {
            get: /**
             * @return {?}
             */ function () {
                return this.itemsFiltered.slice(this.startRow, this.startRow + this.pageSize);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DataGridModel.prototype, "headers", {
            /**
             * Get all headers (column names) and their properties.
             */
            get: /**
             * Get all headers (column names) and their properties.
             * @return {?}
             */ function () {
                return this._headers.filter(( /**
                 * @param {?} h
                 * @return {?}
                 */function (h) { return !h.hidden; }));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DataGridModel.prototype, "headersNotVisible", {
            /**
             * Returns the columns currently not shown. @see addColumn and @see removeColumn for more information.
             */
            get: /**
             * Returns the columns currently not shown. \@see addColumn and \@see removeColumn for more information.
             * @return {?}
             */ function () {
                return this._headers.filter(( /**
                 * @param {?} h
                 * @return {?}
                 */function (h) { return h.hidden; }));
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Simple sort fucntion that makes a array sort call for the specified column.
         * @param colName The column which has to be sorted after.
         // tslint:disable-next-line:max-line-length
         * @param dir The order, descended is *desc*, any other string is ascending. If nothing is provided, the direction toggles. Initital value is *ascending*.
         */
        /**
         * Simple sort fucntion that makes a array sort call for the specified column.
         * @param {?} colName The column which has to be sorted after.
         * // tslint:disable-next-line:max-line-length
         * @param {?} dir The order, descended is *desc*, any other string is ascending. If nothing is provided, the direction toggles. Initital value is *ascending*.
         * @param {?=} sortCallback
         * @return {?}
         */
        DataGridModel.prototype.sortColumn = /**
         * Simple sort fucntion that makes a array sort call for the specified column.
         * @param {?} colName The column which has to be sorted after.
         * // tslint:disable-next-line:max-line-length
         * @param {?} dir The order, descended is *desc*, any other string is ascending. If nothing is provided, the direction toggles. Initital value is *ascending*.
         * @param {?=} sortCallback
         * @return {?}
         */
            function (colName, dir, sortCallback) {
                if (!dir) {
                    // if nothing is provided, toggle current
                    dir = this.sortDirection[colName] === Direction.Ascending ? Direction.Descending : Direction.Ascending;
                }
                // remember last and update UI
                this.sortDirection[colName] = dir;
                if (sortCallback) {
                    this.items.sort(sortCallback);
                }
                else {
                    this.items.sort(( /**
                     * @param {?} a
                     * @param {?} b
                     * @return {?}
                     */function (a, b) {
                        if (dir === Direction.Descending) {
                            return a[colName] > b[colName] ? 1 : -1;
                        }
                        else {
                            return a[colName] > b[colName] ? -1 : 1;
                        }
                    }));
                }
            };
        /**
         * Make a column invisible. This is just changing the render process, the column is still
         * in the headers collection and can be made visible again by calling @see addColumn later.
         */
        /**
         * Make a column invisible. This is just changing the render process, the column is still
         * in the headers collection and can be made visible again by calling \@see addColumn later.
         * @param {?} colname
         * @return {?}
         */
        DataGridModel.prototype.removeColumn = /**
         * Make a column invisible. This is just changing the render process, the column is still
         * in the headers collection and can be made visible again by calling \@see addColumn later.
         * @param {?} colname
         * @return {?}
         */
            function (colname) {
                /** @type {?} */
                var col = this._headers.find(( /**
                 * @param {?} h
                 * @return {?}
                 */function (h) { return h.prop === colname; }));
                if (col) {
                    col.hidden = true;
                }
            };
        /**
         * Add a column to the current grid, that has been removed recently.
         * It's just adding columns that already exists in the headers collection.
         * If the column name provided does not exists, the method does nothing.
         */
        /**
         * Add a column to the current grid, that has been removed recently.
         * It's just adding columns that already exists in the headers collection.
         * If the column name provided does not exists, the method does nothing.
         * @param {?} colname
         * @return {?}
         */
        DataGridModel.prototype.addColumn = /**
         * Add a column to the current grid, that has been removed recently.
         * It's just adding columns that already exists in the headers collection.
         * If the column name provided does not exists, the method does nothing.
         * @param {?} colname
         * @return {?}
         */
            function (colname) {
                /** @type {?} */
                var col = this._headers.find(( /**
                 * @param {?} h
                 * @return {?}
                 */function (h) { return h.prop === colname; }));
                if (col) {
                    col.hidden = false;
                }
            };
        /**
         * Called by infrastructure to inform caller of edit wish
         * @param item The item to edit
         */
        /**
         * Called by infrastructure to inform caller of edit wish
         * @param {?} item The item to edit
         * @return {?}
         */
        DataGridModel.prototype.editItem = /**
         * Called by infrastructure to inform caller of edit wish
         * @param {?} item The item to edit
         * @return {?}
         */
            function (item) {
                this.onEdit.emit(item);
            };
        /**
         * Called by infrastructure to inform caller of delete wish
         * @param item The item to delete
         */
        /**
         * Called by infrastructure to inform caller of delete wish
         * @param {?} item The item to delete
         * @return {?}
         */
        DataGridModel.prototype.deleteItem = /**
         * Called by infrastructure to inform caller of delete wish
         * @param {?} item The item to delete
         * @return {?}
         */
            function (item) {
                this.onDelete.emit(item);
            };
        /**
         * @private
         * @param {?} type
         * @return {?}
         */
        DataGridModel.prototype.createHeadersForType = /**
         * @private
         * @param {?} type
         * @return {?}
         */
            function (type) {
                // assume simple object structure, iterating an array of viewmodels
                // has at least one row, so we can read the headers
                // first we read the properties
                this._headers = new Array();
                for (var p in type) {
                    if (!type.hasOwnProperty(p)) {
                        continue;
                    }
                    // either propname or decorator name
                    /** @type {?} */
                    var propName = type["__displayName__" + p] || p;
                    /** @type {?} */
                    var propDesc = type["__displayDesc__" + p] || p;
                    // check if hidden, show if no hidden decorator
                    /** @type {?} */
                    var isHidden = type["__isHidden__" + p] || false;
                    /** @type {?} */
                    var header = new DataGridHeaderModel(propName, propDesc, p, isHidden);
                    // sorting
                    header.isSortable = type["__isSortable__" + p] === undefined ? true : !!type["__isSortable__" + p];
                    header.sortCallback = type["__sortCallback__" + p] || undefined;
                    // look for templates and pipes provided by user, if none, we have templates for all ES types
                    header.templateHint = type["__templatehint__" + p] || typeof type[p];
                    header.templateHintParams = type["__templatehintParams__" + p];
                    header.pipe = type["__uipipe__" + p];
                    header.pipeParams = type["__pipeparams__" + p];
                    header.uiHint = type["__uiHint__" + p];
                    console.log('h', header);
                    this._headers.push(header);
                }
            };
        return DataGridModel;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * The datagrid provides basic functions for data tables:
     * * sorting
     * * filtering
     * * pagination
     * * editing
     *
     * Provide an decorator enhanced model and the grid appears driven by model meta data.
     *
     * There are many attributes and ways to change the appearance. Also some classes can be controlled by
     * the host component:
     * * `.col-borders`
     * * `.col-last`
     * * `.col-first`
     * All these styles are applied to the <col> elements of the underlying table.
     */
    var DataGridComponent = /** @class */ (function () {
        function DataGridComponent() {
            this.directionEnumHelper = Direction;
            this.externals = {};
            /**
             * Show the action column at all. Use \@see showDeleteButton and  \@see showEditButton to switch the buttons
             * on or off individually. Default is `true` (actions visible).
             */
            this.showActions = true;
            /**
             * The text that appears on the Delete button. Default is 'Delete'.
             */
            this.textDeleteButton = 'Delete';
            /**
             * The text that appears on the Edit button. Default is 'Edit'.
             */
            this.textEditButton = 'Edit';
            /**
             * The column header of the column that shows the buttons. Default is 'Actions'.
             */
            this.textButtonsHeader = 'Actions';
            /**
             * The text that appears if there are no items to show. Can also be overwritten by a more complex piece
             * of code by adding a template like this:
             * \@example
             * <ng-template #data-warning-noitems>
             *   <div class="alert alert-danger">The grid is empty</div>
             * </ng-template>
             */
            this.textNoItems = 'There are no items to show';
            /**
             * Event forwarded from model class and being fired after the model class's onEdit event.
             * The event is invoked by the appropriate internal button via click.
             */
            this.editItem = new core.EventEmitter();
            /**
             * Event forwarded from model class and being fired after the model class's onDelete event.
             * The event is invoked by the appropriate internal button via click.
             */
            this.deleteItem = new core.EventEmitter();
            // tslint:disable-next-line:member-ordering
            this.warnProp = {};
        }
        Object.defineProperty(DataGridComponent.prototype, "filter", {
            /**
             * The filter value to filter the content. The data is of type
             *
             * @example
             * { [prop: string]: any }
             *
             *
             */
            set: /**
             * The filter value to filter the content. The data is of type
             *
             * \@example
             * { [prop: string]: any }
             *
             *
             * @param {?} value
             * @return {?}
             */ function (value) {
                if (this.model) {
                    this.model.searchValue = value;
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        DataGridComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () { };
        /**
         * @return {?}
         */
        DataGridComponent.prototype.ngAfterViewInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                if (this.model) {
                    this.model.onEdit.subscribe(( /**
                     * @param {?} item
                     * @return {?}
                     */function (item) { return _this.editItem.emit(item); }));
                    this.model.onDelete.subscribe(( /**
                     * @param {?} item
                     * @return {?}
                     */function (item) { return _this.deleteItem.emit(item); }));
                }
            };
        /**
         * @return {?}
         */
        DataGridComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                if (this.model) {
                    this.model.onEdit.unsubscribe();
                    this.model.onDelete.unsubscribe();
                }
            };
        /**
         * Controls the template used to display certain data types.
         * If the host provides a template it's being used, otherwise a fallback is provided
         * @param uiHint Property of @UiHint decorator
         */
        /**
         * Controls the template used to display certain data types.
         * If the host provides a template it's being used, otherwise a fallback is provided
         * @param {?} uiHint Property of \@UiHint decorator
         * @param {?=} prop
         * @return {?}
         */
        DataGridComponent.prototype.getActiveTemplate = /**
         * Controls the template used to display certain data types.
         * If the host provides a template it's being used, otherwise a fallback is provided
         * @param {?} uiHint Property of \@UiHint decorator
         * @param {?=} prop
         * @return {?}
         */
            function (uiHint, prop) {
                if (this[uiHint]) {
                    // if provided by user via ContentChild and overwriting defaults (string == string etc.)
                    return this[uiHint];
                }
                if (this.externals[uiHint]) {
                    // if provided by user via ContentChild but completely replaced
                    return this.externals[uiHint];
                }
                if (this[uiHint + "Fallback"]) {
                    // otherwise we take ours from ng-template via ViewChild
                    return this[uiHint + "Fallback"];
                }
                // if we go here the model requested a custom template that didn't exists
                if (this.warnProp[prop] !== uiHint) {
                    console.warn("Property " + prop + " requested the template " + uiHint + ", but it wasn't provided. Falling back to \"string\".");
                    this.warnProp[prop] = uiHint;
                }
                return this.stringFallback;
            };
        DataGridComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ac-datagrid',
                        template: "<div class=\"row\" *ngIf=\"model\">\n  <div class=\"col-md-12\">\n    <table class=\"table table-condensed\">\n      <colgroup class=\"colborders\" [ngStyle]=\"columnStyle ? columnStyle.group : null\">\n        <col class=\"first\" [ngStyle]=\"columnStyle ? columnStyle.first : null\" />\n        <col class=\"middle\" [ngStyle]=\"columnStyle ? columnStyle.middle : null\" />\n        <col class=\"middle\" [ngStyle]=\"columnStyle ? columnStyle.middle : null\" />\n        <col class=\"middle\" [ngStyle]=\"columnStyle ? columnStyle.middle : null\" />\n        <col class=\"last\" [ngStyle]=\"columnStyle ? columnStyle.last : null\" />\n      </colgroup>\n      <thead>\n        <tr [ngStyle]=\"columnStyle ? columnStyle.header : null\" >\n          <th *ngFor=\"let header of model.headers\"\n              [ngClass]=\"{ 'sortableHeader': header.isSortable }\"\n              [ngStyle]=\"header.uiHint\"\n              [title]=\"header.desc\"\n              (click)=\"header.isSortable ? model.sortColumn(header.prop, null, header.sortCallback) : null\">\n            <span class=\"headerText\">{{ header.text }}</span>\n            <span class=\"sort\" [ngStyle]=\"columnStyle ? columnStyle.headerButton : null\" *ngIf=\"header.isSortable\">\n              <button (click)=\"model.sortColumn(header.prop, directionEnumHelper.Ascending, header.sortCallback)\"\n                      class=\"up\"\n                      [hidden]=\"model.sortColumn[header.prop] === directionEnumHelper.Ascending\"\n                      [ngStyle]=\"columnStyle ? columnStyle.headerSortButton : null\">\n                <i class=\"fa fa-sort-asc\"></i>\n              </button>\n              <button (click)=\"model.sortColumn(header.prop, directionEnumHelper.Descending, header.sortCallback)\"\n                      class=\"down\"\n                      [hidden]=\"model.sortColumn[header.prop] === directionEnumHelper.Descending\"\n                      [ngStyle]=\"columnStyle ? columnStyle.headerSortButton : null\">\n                <i class=\"fa fa-sort-desc\"></i>\n              </button>\n            </span>\n            <button (click)=\"model.removeColumn(header.prop)\"\n                    class=\"rearrange\"\n                    [ngStyle]=\"columnStyle ? columnStyle.headerRemoveButton : null\"\n                    *ngIf=\"reArrangeColumns\">\n              <i class=\"fa fa-remove\"></i>\n            </button>\n          </th>\n          <th *ngIf=\"showActions\">\n            {{ textButtonsHeader }}\n          </th>\n        </tr>\n      </thead>\n      <tbody>\n        <tr *ngIf=\"!model.totalFilteredRows\">\n          <td [attr.colspan]=\"model.headers.length\" class=\"text-center\">\n            <div class=\"alert alert-warning\">\n              <span #warningNoItems>\n                <ng-content select=\"[data-warning-noitems]\"></ng-content>\n              </span>\n              <ng-container *ngIf=\"!warningNoItems.innerHTML.trim()\">{{  textNoItems }}</ng-container>\n            </div>\n          </td>\n        </tr>\n        <tr *ngFor=\"let item of model.itemsOnCurrentPage\">\n          <td *ngFor=\"let header of model.headers\">\n            <ng-container\n              [ngTemplateOutlet]=\"getActiveTemplate(header.templateHint, header.prop)\"\n              [ngTemplateOutletContext]=\"{ $implicit: item[header.prop], pipe: header.pipe, params: header.pipeParams }\"\n            ></ng-container>\n          </td>\n          <td *ngIf=\"showActions\" [ngStyle]=\"columnStyle ? columnStyle.actionCell : null\" >\n            <button class=\"btn btn-primary btn-sm\" type=\"button\" (click)=\"model.editItem(item)\">\n              {{ textEditButton }}\n            </button>\n            <button class=\"btn btn-danger btn-sm\" type=\"button\" (click)=\"model.deleteItem(item)\">\n              {{ textDeleteButton }}\n            </button>\n          </td>\n        </tr>\n      </tbody>\n      <tfoot>\n        <tr [ngStyle]=\"columnStyle ? columnStyle.footer : null\" >\n          <td [attr.colspan]=\"model.headers.length + (showActions ? 1 : 0)\">\n            <div #footerRef>\n              <ng-content select=\"[data-footer]\"></ng-content>\n            </div>\n            <ng-container *ngIf=\"!footerRef.innerHTML.trim()\">&copy;</ng-container>\n          </td>\n        </tr>\n      </tfoot>\n    </table>\n  </div>\n</div>\n<ng-template #string let-data let-modelpipe=\"pipe\" let-params=\"params\">\n  {{ data | formatData: modelpipe: params }}\n</ng-template>\n<ng-template #boolean let-data>\n  <input type=\"checkbox\" disabled [checked]=\"data\" />\n</ng-template>\n<ng-template #date let-data>\n  {{ data }}\n</ng-template>\n<ng-template #enum let-data>\n  {{ data }}\n</ng-template>\n<ng-template #number let-data let-modelpipe=\"pipe\" let-params=\"params\">\n  {{ data | formatData: modelpipe: params }}\n</ng-template>\n",
                        styles: [".colborders col{border-right:1px solid azure}col.last{border-right:none!important}col.first{background-color:#eee}th{background:0 0}th.sortableHeader{cursor:pointer}.headerText{overflow:hidden;white-space:nowrap;display:inline-block;text-overflow:ellipsis}.sort{float:right}.sort button{width:16px;height:16px;border-radius:0;padding:1px;border:0;background-color:transparent!important;cursor:pointer;position:relative}.sort button.up{left:0}.sort button.down{left:-16px}.rearrange{width:16px;height:16px;margin:2px;float:right;border:none;background-color:transparent}"]
                    }] }
        ];
        DataGridComponent.propDecorators = {
            stringFallback: [{ type: core.ViewChild, args: ['string',] }],
            string: [{ type: core.ContentChild, args: ['string',] }],
            booleanFallback: [{ type: core.ViewChild, args: ['boolean',] }],
            boolean: [{ type: core.ContentChild, args: ['boolean',] }],
            dateFallback: [{ type: core.ViewChild, args: ['date',] }],
            date: [{ type: core.ContentChild, args: ['date',] }],
            enumFallback: [{ type: core.ViewChild, args: ['enum',] }],
            enum: [{ type: core.ContentChild, args: ['enum',] }],
            numberFallback: [{ type: core.ViewChild, args: ['number',] }],
            number: [{ type: core.ContentChild, args: ['number',] }],
            externals: [{ type: core.Input }],
            columnStyle: [{ type: core.Input }],
            model: [{ type: core.Input }],
            showDeleteButton: [{ type: core.Input }],
            showEditButton: [{ type: core.Input }],
            showActions: [{ type: core.Input }],
            textDeleteButton: [{ type: core.Input }],
            textEditButton: [{ type: core.Input }],
            textButtonsHeader: [{ type: core.Input }],
            textNoItems: [{ type: core.Input }],
            filter: [{ type: core.Input }],
            reArrangeColumns: [{ type: core.Input }],
            editItem: [{ type: core.Output }],
            deleteItem: [{ type: core.Output }]
        };
        return DataGridComponent;
    }());

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * This pipe allows the dynamic formatting of data. It is just for internal use.
     * The purpose is the forwarding of an externally defined pipe to the pipe formatter within the grid.
     */
    var FormatDataPipe = /** @class */ (function () {
        function FormatDataPipe(injector) {
            this.injector = injector;
        }
        /**
         * @param {?} value
         * @param {?} pipeToken
         * @param {?} pipeArgs
         * @return {?}
         */
        FormatDataPipe.prototype.transform = /**
         * @param {?} value
         * @param {?} pipeToken
         * @param {?} pipeArgs
         * @return {?}
         */
            function (value, pipeToken, pipeArgs) {
                if (!pipeToken) {
                    console.log('FormatDataPipe:NoPipeToken');
                    return value;
                }
                else {
                    console.log('FormatDataPipe:PipeToken:', pipeToken);
                    /** @type {?} */
                    var pipe = this.injector.get(pipeToken);
                    return pipe.transform.apply(pipe, __spread([value], pipeArgs || []));
                }
            };
        FormatDataPipe.decorators = [
            { type: core.Pipe, args: [{
                        name: 'formatData'
                    },] }
        ];
        /** @nocollapse */
        FormatDataPipe.ctorParameters = function () {
            return [
                { type: core.Injector }
            ];
        };
        return FormatDataPipe;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * The Editor Widget. Creates a field with all required validators using decorators and forms service.
     */
    var EditorComponent = /** @class */ (function () {
        function EditorComponent() {
            /**
             * Editor type. Default is 'text';
             */
            this.type = 'text';
            /**
             * A character after the fields label. Default is ': ' (colon plus space);
             */
            this.labelDivider = ': ';
            /**
             * If set to true the label and the field appears in one row.
             * Otherwise the label is above the field. Default is `true`.
             */
            this.inline = true;
            /**
             * The start value for a range field. Other field types ignore this value.
             */
            this.fromValue = 0;
            /**
             * The end value for a range field. Other field types ignore this value.
             */
            this.toValue = 100;
            /**
             * An optional placeholder for empty field. The default is empty (no watermark).
             */
            this.waterMark = '';
            /**
             * Renders the field as read only.
             */
            this.readonly = false;
            this.params = new Array();
        }
        /**
         * @param {?} key
         * @return {?}
         */
        EditorComponent.prototype.getParams = /**
         * @param {?} key
         * @return {?}
         */
            function (key) {
                return this.first(this.params.filter(( /**
                 * @param {?} e
                 * @return {?}
                 */function (e) { return e.key === key; })), 0);
            };
        /**
         * @param {?} array
         * @param {?} n
         * @return {?}
         */
        EditorComponent.prototype.first = /**
         * @param {?} array
         * @param {?} n
         * @return {?}
         */
            function (array, n) {
                if (array == null) {
                    return void 0;
                }
                if (n == null) {
                    return array[0];
                }
                if (n < 0) {
                    return [];
                }
                return array.slice(0, n);
            };
        /**
         * @return {?}
         */
        EditorComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this.formGroup.valueChanges.subscribe(( /**
                 * @param {?} data
                 * @return {?}
                 */function (data) { return _this.onValueChanged(data); }));
                // this is set by FormValidatorService
                /** @type {?} */
                var editorModel = (( /** @type {?} */(this.formGroup)))['__editorModel__'];
                // get type from form
                if (editorModel) {
                    // get elementary types, this might get overwritten later according to decorators found
                    if (typeof editorModel[this.name] === 'string') {
                        this.type = 'text';
                    }
                    if (typeof editorModel[this.name] === 'boolean') {
                        this.type = 'boolean';
                    }
                    if (typeof editorModel[this.name] === 'number') {
                        this.type = 'number';
                    }
                    if (editorModel[this.name] instanceof Date) {
                        this.type = 'calendar';
                    }
                    // make an instance to read the properties
                    this.label = editorModel["__displayName__" + this.name] || this.label || this.name;
                    this.tooltip = editorModel["__displayDesc__" + this.name] || this.tooltip || this.name;
                    // render as range id there is a range definition
                    if (editorModel["__hasRangeFrom__" + this.name] && Number(editorModel["__hasRangeFrom__" + this.name])) {
                        this.fromValue = ( /** @type {?} */(editorModel["__hasRangeFrom__" + this.name]));
                        this.type = 'range';
                    }
                    if (editorModel["__hasRangeTo__" + this.name] && Number(editorModel["__hasRangeTo__" + this.name])) {
                        this.toValue = ( /** @type {?} */(editorModel["__hasRangeTo__" + this.name]));
                        this.type = 'range';
                    }
                    // placeholder
                    if (editorModel["__hasWatermark__" + this.name]) {
                        this.waterMark = editorModel["__watermark__" + this.name];
                    }
                    // templates
                    if (editorModel["__hasTemplateHint__" + this.name]) {
                        this.type = (( /** @type {?} */(editorModel["__templatehint__" + this.name]))).toLowerCase();
                        if (editorModel["__templatehintParams__" + this.name]) {
                            this.params = ( /** @type {?} */(editorModel["__templatehintParams__" + this.name]));
                        }
                    }
                    // render hidden fields as hidden even in forms
                    if (editorModel["__isHidden__" + this.name]) {
                        this.type = 'hidden';
                    }
                    // check readonly
                    if (editorModel["__isReadonly__" + this.name]) {
                        this.readonly = !!editorModel["__isReadonly__" + this.name];
                    }
                }
            };
        /**
         * @private
         * @param {?} data
         * @return {?}
         */
        EditorComponent.prototype.onValueChanged = /**
         * @private
         * @param {?} data
         * @return {?}
         */
            function (data) {
                // check validation on change
                this.errors = new Array();
                // tslint:disable-next-line:forin
                for (var error in this.formGroup.controls[this.name].errors) {
                    this.errors.push(error);
                }
            };
        EditorComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ac-editor',
                        template: "<div class=\"form-group row\"\n    [formGroup]=\"formGroup\"\n     *ngIf=\"type != 'hidden' && formGroup\"\n     [ngClass]=\"{ 'has-danger': !formGroup.controls[name].valid && formGroup.controls[name].touched }\">\n  <label class=\"col-form-label col-md-3 col-sm-10\"\n    [attr.for]=\"name\"\n    [attr.title]=\"tooltip\" >{{ label }}{{ labelDivider }} </label>\n  <div [ngClass]=\"{ 'col-md-7 col-sm-10': inline }\">\n    <textarea *ngIf=\"type == 'textarea'\"\n            class=\"form-control\"\n            [id]=\"name\"\n            [readOnly]='readonly'\n            [formControlName]=\"name\"\n            [attr.rows]=\"getParams('rows')\"\n            [attr.cols]=\"getParams('cols')\">\n    </textarea>\n    <select *ngIf=\"type == 'enum' && enumValues\" class=\"form-control\" [id]=\"name\"\n          [formControlName]=\"name\" [disabled]='readonly'>\n      <option *ngFor=\"let option of enumValues\" [value]=\"option.key\">{{option.val}}</option>\n    </select>\n    <select *ngIf=\"type == 'list' && listValues\" class=\"form-control\" [id]=\"name\"\n          [formControlName]=\"name\" [disabled]='readonly'>\n      <option *ngFor=\"let option of listValues\" [value]=\"option.key\">{{option.val}}</option>\n    </select>\n    <input *ngIf=\"type == 'range'\" type=\"range\"\n        class=\"form-control\"\n        [placeholder]=\"waterMark\"\n        [attr.minvalue]=\"fromValue\"\n        [attr.maxvalue]=\"toValue\"\n        [attr.min]=\"fromValue\"\n        [attr.max]=\"toValue\"\n        [id]=\"name\"\n        [formControlName]=\"name\"\n        [title]=\"tooltip\" />\n    <input *ngIf=\"type == 'calendar'\" type=\"date\"\n        class=\"form-control\"\n        [placeholder]=\"waterMark\"\n        [readOnly]='readonly'\n        [id]=\"name\"\n        [formControlName]=\"name\"\n        [title]=\"tooltip\" />\n    <input *ngIf=\"type == 'number'\" type=\"number\"\n        class=\"form-control\"\n        [placeholder]=\"waterMark\"\n        [readOnly]='readonly'\n        [id]=\"name\"\n        [formControlName]=\"name\"\n        [title]=\"tooltip\" />\n    <input *ngIf=\"type == 'boolean'\" type=\"checkbox\"\n        class=\"form-control\"\n        [readOnly]='readonly'\n        [id]=\"name\"\n        [formControlName]=\"name\"\n        [title]=\"tooltip\" />\n    <label *ngIf=\"type == 'boolean'\" [attr.for]=\"name\"></label>\n    <input *ngIf=\"type == 'text' || type == ''\" [placeholder]=\"waterMark\"\n        [readOnly]='readonly'\n        type=\"text\" class=\"form-control\" [id]=\"name\" [formControlName]=\"name\" />\n    <ng-container *ngIf=\"type == 'template'\">\n        <ng-content></ng-content>\n    </ng-container>\n    <span class=\"fa fa-warning text-danger form-control-feedback\"\n        [hidden]=\"formGroup.controls[name].valid || formGroup.controls[name].pristine\"></span>\n    <small class=\"text-danger\"\n        [hidden]=\"formGroup.controls[name].valid || formGroup.controls[name].pristine\">\n    <span *ngFor=\"let error of errors\">{{ formGroup.controls[name]['messages'][error] }}</span>\n    </small>\n  </div>\n</div>\n<div>\n  <input *ngIf=\"type == 'hidden'\" [id]=\"name\" [formControlName]=\"name\" type=\"hidden\" />\n</div>\n",
                        styles: ['input[type="checkbox"] { display: none; }',
                            'input[type="checkbox"] + label:before { font-family: FontAwesome; }',
                            'input[type="checkbox"] + label:before { content: "\\f096"; }',
                            'input[type="checkbox"]:checked + label:before { content: "\\f046"; }',
                            "\n      input[type='checkbox'] + label {\n        display: inline-block;\n        width: 15px;\n        height: 20px;\n        margin: -1px 4px 0 0;\n        vertical-align: middle;\n        cursor: pointer;\n      }\n    "]
                    }] }
        ];
        /** @nocollapse */
        EditorComponent.ctorParameters = function () { return []; };
        EditorComponent.propDecorators = {
            name: [{ type: core.Input }],
            type: [{ type: core.Input }],
            labelDivider: [{ type: core.Input }],
            label: [{ type: core.Input }],
            tooltip: [{ type: core.Input }],
            formGroup: [{ type: core.Input }],
            inline: [{ type: core.Input }],
            enumValues: [{ type: core.Input }],
            listValues: [{ type: core.Input }],
            fromValue: [{ type: core.Input }],
            toValue: [{ type: core.Input }],
            waterMark: [{ type: core.Input }],
            readonly: [{ type: core.Input }],
            value: [{ type: core.Output }, { type: core.Input }]
        };
        return EditorComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * This component creates a complete editor out of a viewmodel.
     * It creates one field for each property not decorated with \@Hidden.
     *
     */
    var AutoFormComponent = /** @class */ (function () {
        function AutoFormComponent() {
            /**
             * Ungrouped element will appear at the end, after all groupes.
             * If there are no groups this will be ignored. Optional.
             */
            this.ungroupedAfter = true;
            this.editors = new Array();
            this.groups = new Array();
        }
        /**
         * @return {?}
         */
        AutoFormComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                // take all controls as is
                /** @type {?} */
                var hasDecorators = (( /** @type {?} */(this.formGroup)))['__editorModel__'];
                var _loop_1 = function (controlName) {
                    if (!this_1.formGroup.controls.hasOwnProperty(controlName)) {
                        return "continue";
                    }
                    /** @type {?} */
                    var displayOrder = 0;
                    /** @type {?} */
                    var groupOrder = 0;
                    /** @type {?} */
                    var groupName;
                    /** @type {?} */
                    var groupDesc = void 0;
                    /** @type {?} */
                    var isInGroup = false;
                    if (hasDecorators) {
                        displayOrder = (( /** @type {?} */(this_1.formGroup)))['__editorModel__']["__displayOrder__" + controlName];
                        isInGroup = !!(( /** @type {?} */(this_1.formGroup)))['__editorModel__']["__isGrouped__" + controlName];
                        if (isInGroup) {
                            groupName = (( /** @type {?} */(this_1.formGroup)))['__editorModel__']["__groupName__" + controlName];
                            groupOrder = (( /** @type {?} */(this_1.formGroup)))['__editorModel__']["__groupOrder__" + controlName];
                            groupDesc = (( /** @type {?} */(this_1.formGroup)))['__editorModel__']["__groupDesc__" + controlName];
                        }
                    }
                    if (!isInGroup) {
                        // if not part of any group just push to main group
                        this_1.editors.push({
                            key: displayOrder,
                            editor: controlName
                        });
                    }
                    else {
                        // check if group already exists
                        /** @type {?} */
                        var existingGroupArray = this_1.groups.filter(( /**
                         * @param {?} g
                         * @return {?}
                         */function (g) { return g.name === groupName; }));
                        /** @type {?} */
                        var groupExists = existingGroupArray.length === 1;
                        if (!groupExists) {
                            this_1.groups.push({
                                key: groupOrder,
                                name: groupName,
                                desc: groupDesc,
                                editors: new Array()
                            });
                        }
                        // add field to existing group (assume that here the group always exists)
                        /** @type {?} */
                        var existingGroup = this_1.groups.filter(( /**
                         * @param {?} g
                         * @return {?}
                         */function (g) { return g.name === groupName; }))[0];
                        // and store
                        existingGroup.editors.push({
                            key: displayOrder,
                            editor: controlName
                        });
                    }
                };
                var this_1 = this;
                // loop through all fields
                for (var controlName in this.formGroup.controls) {
                    _loop_1(controlName);
                }
                // check the display decorator and sort
                this.editors.sort(( /**
                 * @param {?} e
                 * @param {?} n
                 * @return {?}
                 */function (e, n) { return e.key - n.key; }));
                // sort groups
                this.groups.sort(( /**
                 * @param {?} e
                 * @param {?} n
                 * @return {?}
                 */function (e, n) { return e.key - n.key; }));
            };
        /**
         * @return {?}
         */
        AutoFormComponent.prototype.grouped = /**
         * @return {?}
         */
            function () {
                return this.groups && this.groups.length > 0;
            };
        AutoFormComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ac-autoform',
                        template: "<ng-content></ng-content>\n<ng-container *ngIf=\"!ungroupedAfter\">\n  <ac-editor *ngFor=\"let editor of editors\" [name]=\"editor.editor\" [formGroup]=\"formGroup\"></ac-editor>\n</ng-container>\n<ng-container *ngIf=\"grouped()\">\n  <fieldset *ngFor=\"let group of groups\">\n    <legend [attr.title]=\"group.desc\" *ngIf=\"group.name\">{{ group.name }}</legend>\n    <ac-editor *ngFor=\"let editor of group.editors\" [name]=\"editor.editor\" [formGroup]=\"formGroup\"></ac-editor>\n  </fieldset>\n</ng-container>\n<ng-container *ngIf=\"ungroupedAfter\">\n  <ac-editor *ngFor=\"let editor of editors\" [name]=\"editor.editor\" [formGroup]=\"formGroup\"></ac-editor>\n</ng-container>\n",
                        styles: ['fieldset { border-top: 1px silver solid; padding: 10px; }',
                            'legend { width: auto; padding-left: 10px; padding-right: 10px; font-size: 1em;}']
                    }] }
        ];
        /** @nocollapse */
        AutoFormComponent.ctorParameters = function () { return []; };
        AutoFormComponent.propDecorators = {
            formGroup: [{ type: core.Input }],
            ungroupedAfter: [{ type: core.Input }]
        };
        return AutoFormComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A treeview that can handle \@see TreeNodeModel objects that create text, checkboxes, or highlights.
     * A node can have an icon. The icons are based on FontAwesome's css classes.
     */
    var TreeViewComponent = /** @class */ (function () {
        function TreeViewComponent() {
            this.nodeClick = new core.EventEmitter();
            this.checkChanged = new core.EventEmitter();
            this.selectedChanged = new core.EventEmitter();
            this.collapseChanged = new core.EventEmitter();
        }
        /**
         * @param {?} node
         * @return {?}
         */
        TreeViewComponent.prototype.onNodeClick = /**
         * @param {?} node
         * @return {?}
         */
            function (node) {
                this.nodeClick.emit(node);
            };
        /**
         * @param {?} node
         * @return {?}
         */
        TreeViewComponent.prototype.onCheckChanged = /**
         * @param {?} node
         * @return {?}
         */
            function (node) {
                this.checkChanged.emit(node);
            };
        /**
         * @param {?} node
         * @return {?}
         */
        TreeViewComponent.prototype.onSelectedChanged = /**
         * @param {?} node
         * @return {?}
         */
            function (node) {
                this.selectedChanged.emit(node);
            };
        /**
         * @param {?} node
         * @return {?}
         */
        TreeViewComponent.prototype.onCollapseChanged = /**
         * @param {?} node
         * @return {?}
         */
            function (node) {
                this.collapseChanged.emit(node);
            };
        TreeViewComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ac-tree',
                        template: "<ul class=\"treeview\">\n  <ac-treenode\n    [node]=\"nodes\"\n    (nodeClick)=\"onNodeClick($event)\"\n    (checkChanged)=\"onCheckChanged($event)\"\n    (selectedChanged)=\"onSelectedChanged($event)\"\n    (collapseChanged)=\"onCollapseChanged($event)\"\n  ></ac-treenode>\n</ul>\n",
                        styles: ['.treeview { list-style: none; margin-left: -25px; }']
                    }] }
        ];
        /** @nocollapse */
        TreeViewComponent.ctorParameters = function () { return []; };
        TreeViewComponent.propDecorators = {
            nodes: [{ type: core.Input }],
            nodeClick: [{ type: core.Output }],
            checkChanged: [{ type: core.Output }],
            selectedChanged: [{ type: core.Output }],
            collapseChanged: [{ type: core.Output }]
        };
        return TreeViewComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {number} */
    var TreeNodeState = {
        undefined: 0,
        checked: 1,
        disabled: 2,
        expanded: 4,
        selected: 8,
    };
    TreeNodeState[TreeNodeState.undefined] = 'undefined';
    TreeNodeState[TreeNodeState.checked] = 'checked';
    TreeNodeState[TreeNodeState.disabled] = 'disabled';
    TreeNodeState[TreeNodeState.expanded] = 'expanded';
    TreeNodeState[TreeNodeState.selected] = 'selected';
    /**
     * The view options of node
     */
    var /**
     * The view options of node
     */ TreeNodeOptions = /** @class */ (function () {
        function TreeNodeOptions(options) {
        }
        return TreeNodeOptions;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * The base class for tree nodes.
     */
    var /**
     * The base class for tree nodes.
     */ TreeNodeModel = /** @class */ (function () {
        function TreeNodeModel(options, nodes) {
            this.options = options || new TreeNodeOptions();
            if (nodes && nodes instanceof Array) {
                this.children = ( /** @type {?} */(nodes));
            }
            else {
                if (nodes) {
                    this.children = [( /** @type {?} */(nodes))];
                }
            }
            this.stateChange = new core.EventEmitter();
            this.state = TreeNodeState.undefined;
        }
        Object.defineProperty(TreeNodeModel.prototype, "path", {
            get: /**
             * @return {?}
             */ function () {
                // walk up tree and return path with names
                /** @type {?} */
                var p = new Array();
                p.push(this);
                /** @type {?} */
                var n = this;
                while (this.parent) {
                    n = n.parent;
                    p.push(n);
                }
                return p;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} node
         * @return {?}
         */
        TreeNodeModel.prototype.hasDirectAncestor = /**
         * @param {?} node
         * @return {?}
         */
            function (node) {
                return this.parent !== undefined;
            };
        Object.defineProperty(TreeNodeModel.prototype, "hasChildren", {
            get: /**
             * @return {?}
             */ function () {
                return this.children !== undefined && this.children.length > 0;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} nodes
         * @return {?}
         */
        TreeNodeModel.prototype.add = /**
         * @param {?} nodes
         * @return {?}
         */
            function (nodes) {
                var _a;
                if (nodes && nodes instanceof Array) {
                    (_a = this.children).push.apply(_a, __spread(( /** @type {?} */(nodes))));
                }
                else {
                    this.children.push(( /** @type {?} */(nodes)));
                }
            };
        /**
         * @param {?} node
         * @return {?}
         */
        TreeNodeModel.prototype.remove = /**
         * @param {?} node
         * @return {?}
         */
            function (node) {
                /** @type {?} */
                var idx = this.children.indexOf(node);
                if (idx > -1) {
                    this.children.splice(idx, 1);
                    return true;
                }
                else {
                    return false;
                }
            };
        Object.defineProperty(TreeNodeModel.prototype, "state", {
            get: /**
             * @return {?}
             */ function () {
                return this._state;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */ function (value) {
                this._state = value;
                if (!this.hasChildren && (this.state & TreeNodeState.expanded) === TreeNodeState.expanded) {
                    // if an expandable event occurs and there a no children, don't fire
                    return;
                }
                this.stateChange.emit(this._state);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TreeNodeModel.prototype, "stateIsExpandend", {
            get: /**
             * @return {?}
             */ function () {
                return (this.state & TreeNodeState.expanded) === TreeNodeState.expanded;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TreeNodeModel.prototype, "stateIsDisabled", {
            get: /**
             * @return {?}
             */ function () {
                return (this.state & TreeNodeState.disabled) === TreeNodeState.disabled;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TreeNodeModel.prototype, "stateIsSelected", {
            get: /**
             * @return {?}
             */ function () {
                return (this.state & TreeNodeState.selected) === TreeNodeState.selected;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TreeNodeModel.prototype, "stateIsChecked", {
            get: /**
             * @return {?}
             */ function () {
                return (this.state & TreeNodeState.checked) === TreeNodeState.checked;
            },
            enumerable: true,
            configurable: true
        });
        return TreeNodeModel;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A text node
     */
    var /**
     * A text node
     */ TextTreeNodeModel = /** @class */ (function (_super) {
        __extends(TextTreeNodeModel, _super);
        function TextTreeNodeModel(text, options, nodes) {
            var _this = _super.call(this, options, nodes) || this;
            _this.text = text;
            _this.name = text; // default, must be set explicitly
            return _this;
        }
        return TextTreeNodeModel;
    }(TreeNodeModel));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * This type can load a component's UI into the node.
     */
    var /**
     * This type can load a component's UI into the node.
     */ TreeNodeComponentModel = /** @class */ (function (_super) {
        __extends(TreeNodeComponentModel, _super);
        function TreeNodeComponentModel(component, options, nodes) {
            var _this = _super.call(this, options, nodes) || this;
            _this.component = component;
            return _this;
        }
        return TreeNodeComponentModel;
    }(TreeNodeModel));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * The TreeNodeModel class represents a single TreeNodeModel for the treeview. Actually, this renders the real UI.
     *
     * The component needs this input value:
     *
     * * \@Input() node: AcTextTreeNode;
     *
     * The several options are set through the AcTreeNodeOptions object that is being held by the
     * AcTextTreeNode class. This includes colors, icons, and other styles.
     *
     * The component can fire these events:
     *
     * * \@Output() nodeClick: EventEmitter<AcTreeNode>;
     * * \@Output() checkChanged: EventEmitter<AcTreeNode>;
     * * \@Output() selectedChanged: EventEmitter<AcTreeNode>;
     * * \@Output() collapseChanged: EventEmitter<AcTreeNode>;
     *
     */
    var TreeViewNodeComponent = /** @class */ (function () {
        function TreeViewNodeComponent(el, renderer) {
            this.el = el;
            this.renderer = renderer;
            this.isExpanded = false;
            this.nodeClick = new core.EventEmitter();
            this.checkChanged = new core.EventEmitter();
            this.selectedChanged = new core.EventEmitter();
            this.collapseChanged = new core.EventEmitter();
        }
        /**
         * @return {?}
         */
        TreeViewNodeComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                // set HTML according to options
                this.collapseClasses = new Array();
                this.iconClasses = new Array();
                // expander area with icon
                if (this.node) {
                    // expect a font-awesome class with or without fa class
                    if (this.node.options && this.node.options.icon) {
                        if (this.node.options.icon.indexOf(TreeViewNodeComponent.pfxIcon + " ") !== 0) {
                            this.iconClasses.push('fa');
                        }
                        this.iconClasses.push(this.node.options.icon);
                    }
                    if (this.node.options && this.node.options.href) {
                        this.href = this.node.options.href;
                    }
                    else {
                        this.href = '';
                    }
                    // open/close area for elements with children
                    if (this.node.hasChildren) {
                        this.collapseClasses.push('ac-icon'); // base class
                        this.collapseClasses.push(TreeViewNodeComponent.pfxIcon);
                        this.collapseClasses.push(TreeViewNodeComponent.opnIcon);
                        // collapsed by default
                        this.node.state &= ~TreeNodeState.checked;
                    }
                    if (this.node.options && this.node.options.color) {
                        this.foreColor = this.node.options.color;
                    }
                    if (this.node.options && this.node.options.backColor) {
                        this.backColor = this.node.options.backColor;
                    }
                    this.node.stateChange.subscribe(( /**
                     * @param {?} se
                     * @return {?}
                     */function (se) {
                        _this.collapseChanged.emit(_this.node);
                        if (!_this.node.stateIsExpandend) {
                            _this.collapseClasses = _this.collapseClasses.filter(( /**
                             * @param {?} s
                             * @return {?}
                             */function (s) { return s !== TreeViewNodeComponent.clsIcon; }));
                            _this.collapseClasses.push(TreeViewNodeComponent.opnIcon);
                        }
                        else {
                            _this.collapseClasses = _this.collapseClasses.filter(( /**
                             * @param {?} s
                             * @return {?}
                             */function (s) { return s !== TreeViewNodeComponent.opnIcon; }));
                            _this.collapseClasses.push(TreeViewNodeComponent.clsIcon);
                        }
                        _this.isExpanded = _this.node.stateIsExpandend;
                    }));
                }
            };
        // forward events in the node tree
        // forward events in the node tree
        /**
         * @param {?} node
         * @return {?}
         */
        TreeViewNodeComponent.prototype.onNodeClick =
            // forward events in the node tree
            /**
             * @param {?} node
             * @return {?}
             */
            function (node) {
                this.nodeClick.emit(node);
            };
        /**
         * @param {?} node
         * @return {?}
         */
        TreeViewNodeComponent.prototype.onCheckChanged = /**
         * @param {?} node
         * @return {?}
         */
            function (node) {
                this.checkChanged.emit(node);
            };
        /**
         * @param {?} node
         * @return {?}
         */
        TreeViewNodeComponent.prototype.onSelectedChanged = /**
         * @param {?} node
         * @return {?}
         */
            function (node) {
                this.selectedChanged.emit(node);
            };
        /**
         * @param {?} node
         * @return {?}
         */
        TreeViewNodeComponent.prototype.onCollapseChanged = /**
         * @param {?} node
         * @return {?}
         */
            function (node) {
                if (this.node.options.collapsable && this.node.hasChildren) {
                    this.collapseChanged.emit(node);
                }
            };
        /**
         * @return {?}
         */
        TreeViewNodeComponent.prototype.handleCheckChange = /**
         * @return {?}
         */
            function () {
                if (this.node.options.checkable && !this.node.stateIsDisabled) {
                    if (this.node.state & TreeNodeState.checked) {
                        this.node.state &= ~TreeNodeState.checked;
                    }
                    else {
                        this.node.state |= TreeNodeState.checked;
                    }
                    this.checkChanged.emit(this.node);
                }
            };
        /**
         * @param {?} $event
         * @return {?}
         */
        TreeViewNodeComponent.prototype.handleClick = /**
         * @param {?} $event
         * @return {?}
         */
            function ($event) {
                $event.stopPropagation();
                // always emit click
                this.nodeClick.emit(this.node);
            };
        /**
         * @return {?}
         */
        TreeViewNodeComponent.prototype.handleCollapse = /**
         * @return {?}
         */
            function () {
                // if collapsable handle icons and view state
                if (this.node.options.collapsable) {
                    // toggle state
                    if (this.node.state && this.node.state & TreeNodeState.expanded) {
                        this.node.state &= ~TreeNodeState.expanded;
                    }
                    else {
                        this.node.state |= TreeNodeState.expanded;
                    }
                }
            };
        /**
         * @param {?} state
         * @return {?}
         */
        TreeViewNodeComponent.prototype.handlePreSelection = /**
         * @param {?} state
         * @return {?}
         */
            function (state) {
                // handle the states according to options
                if (this.node.options.selectable && !this.node.stateIsDisabled) {
                    if (state) {
                        if (this.node.options && this.node.options.color) {
                            this.foreColor = this.node.options.backColor;
                        }
                        else {
                            this.foreColor = '#fff';
                        }
                        if (this.node.options && this.node.options.backColor) {
                            this.backColor = this.node.options.color;
                        }
                        else {
                            this.backColor = '#000';
                        }
                    }
                    else {
                        if (this.node.options && this.node.options.color) {
                            this.foreColor = this.node.options.color;
                        }
                        else {
                            this.foreColor = '#000';
                        }
                        if (this.node.options && this.node.options.backColor) {
                            this.backColor = this.node.options.backColor;
                        }
                        else {
                            this.backColor = '#fff';
                        }
                    }
                    this.preSelectState = state;
                }
            };
        /**
         * @param {?} $event
         * @return {?}
         */
        TreeViewNodeComponent.prototype.handleSelection = /**
         * @param {?} $event
         * @return {?}
         */
            function ($event) {
                // handle the states according to options
                if (this.node.options.selectable &&
                    !this.node.stateIsDisabled &&
                    this.preSelectState === true) {
                    if (this.node.state & TreeNodeState.selected) {
                        this.node.state &= ~TreeNodeState.selected;
                    }
                    else {
                        this.node.state |= TreeNodeState.selected;
                    }
                    if (this.node.stateIsSelected) {
                        if (this.node.options && this.node.options.color) {
                            this.foreColor = this.node.options.backColor;
                        }
                        else {
                            this.foreColor = '#fff';
                        }
                        if (this.node.options && this.node.options.backColor) {
                            this.backColor = this.node.options.color;
                        }
                        else {
                            this.backColor = '#000';
                        }
                    }
                    else {
                        if (this.node.options && this.node.options.color) {
                            this.foreColor = this.node.options.color;
                        }
                        else {
                            this.foreColor = '#000';
                        }
                        if (this.node.options && this.node.options.backColor) {
                            this.backColor = this.node.options.backColor;
                        }
                        else {
                            this.backColor = '#fff';
                        }
                    }
                    this.selectedChanged.emit(this.node);
                }
                if (!this.href) {
                    $event.preventDefault();
                    $event.stopPropagation();
                }
            };
        TreeViewNodeComponent.pfxIcon = 'fa';
        TreeViewNodeComponent.opnIcon = 'fa-plus';
        TreeViewNodeComponent.clsIcon = 'fa-minus';
        TreeViewNodeComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ac-treenode',
                        template: "<li class=\"treeview\" (click)=\"handleClick($event)\">\n    <i class=\"ac-collapse\" [ngClass]=\"collapseClasses\" *ngIf=\"node.hasChildren\" (click)=\"handleCollapse()\"></i>\n    <i class=\"ac-collapse\" *ngIf=\"!node.hasChildren\"></i>\n    <i class=\"ac-icon\" [ngClass]=\"iconClasses\" [style.color]=\"node.options.iconColor\" *ngIf=\"!node.options.checkable\"></i>\n    <input type=\"checkbox\" [id]=\"node.name\" *ngIf=\"node.options.checkable\" \n           [checked]=\"node.stateIsChecked\" (click)=\"handleCheckChange()\">\n    <label [attr.for]=\"node.name\"></label>\n    <a class=\"ac-container\"\n          [href]=\"href\"\n          [style.color]=\"foreColor\" \n          [style.background-color]=\"backColor\" \n          (mouseover)=\"handlePreSelection(true)\"\n          (mouseout)=\"handlePreSelection(false)\"\n          (click)=\"handleSelection($event)\">\n        {{ node.text }}\n    </a>\n    <ul class=\"treeview\" *ngIf=\"node.hasChildren\" [hidden]=\"!isExpanded\">\n        <ac-treenode *ngFor=\"let child of node.children\" \n                     [node]=\"child\"\n                     (nodeClick)=\"onNodeClick($event)\" \n                     (checkChanged)=\"onCheckChanged($event)\"\n                     (selectedChanged)=\"onSelectedChanged($event)\"\n                     (collapseChanged)=\"onCollapseChanged($event)\">\n        </ac-treenode>\n    </ul>                   \n</li>",
                        styles: ["ul.treeview{list-style:none;margin-left:-2em}li.treeview{margin-left:10px;margin-bottom:3px;box-sizing:border-box}li.treeview a.ac-container{border-radius:2px;display:inline-block;padding:3px;text-decoration:none}li.treeview input[type=checkbox]{display:none}li.treeview input[type=checkbox]+label:before{font-family:FontAwesome;content:\"\\f096\"}li.treeview input[type=checkbox]:checked+label:before{content:\"\\f046\"}li.treeview input[type=checkbox]+label{display:inline-block;width:15px;height:20px;margin:-1px 4px 0 0;vertical-align:middle;cursor:pointer}li.treeview i.ac-collapse{width:15px;cursor:pointer;display:inline-block;margin-left:-1.7em}li.treeview i.ac-icon{width:15px;cursor:pointer;display:inline-block}li.treeview .ac-node-disabled{color:silver;cursor:not-allowed}"]
                    }] }
        ];
        /** @nocollapse */
        TreeViewNodeComponent.ctorParameters = function () {
            return [
                { type: core.ElementRef },
                { type: core.Renderer2 }
            ];
        };
        TreeViewNodeComponent.propDecorators = {
            node: [{ type: core.Input }],
            nodeClick: [{ type: core.Output }],
            checkChanged: [{ type: core.Output }],
            selectedChanged: [{ type: core.Output }],
            collapseChanged: [{ type: core.Output }]
        };
        return TreeViewNodeComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var SVOGV_COMPONENTS = [
        DataGridComponent,
        DataGridPaginationComponent,
        TreeViewComponent,
        TreeViewNodeComponent,
        EditorComponent,
        AutoFormComponent
    ];
    /** @type {?} */
    var provider = [FormValidatorService, FormValidatorFromJsonService];
    /**
     * The actual SVOGV Module definition using the root module.
     */
    var SvogvModule = /** @class */ (function () {
        function SvogvModule() {
        }
        /**
         * @return {?}
         */
        SvogvModule.forRoot = /**
         * @return {?}
         */
            function () {
                return {
                    ngModule: SvogvModule,
                    providers: provider
                };
            };
        SvogvModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule, router.RouterModule, forms.ReactiveFormsModule, forms.FormsModule],
                        declarations: __spread(SVOGV_COMPONENTS, [FormatDataPipe]),
                        providers: provider,
                        exports: __spread(SVOGV_COMPONENTS)
                    },] }
        ];
        return SvogvModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.Required = Required;
    exports.requiredInternalSetup = requiredInternalSetup;
    exports.MaxLength = MaxLength;
    exports.maxLengthInternalSetup = maxLengthInternalSetup;
    exports.MinLength = MinLength;
    exports.minLengthInternalSetup = minLengthInternalSetup;
    exports.StringLength = StringLength;
    exports.stringLengthInternalSetup = stringLengthInternalSetup;
    exports.Pattern = Pattern;
    exports.patternInternalSetup = patternInternalSetup;
    exports.Email = Email;
    exports.emailInternalSetup = emailInternalSetup;
    exports.Range = Range;
    exports.rangeInternalSetup = rangeInternalSetup;
    exports.Compare = Compare;
    exports.compareInternalSetup = compareInternalSetup;
    exports.Display = Display;
    exports.displayInternalSetup = displayInternalSetup;
    exports.UiHint = UiHint;
    exports.uiHintInternalSetup = uiHintInternalSetup;
    exports.DisplayGroup = DisplayGroup;
    exports.displayGroupInternalSetup = displayGroupInternalSetup;
    exports.Placeholder = Placeholder;
    exports.placeholderInternalSetup = placeholderInternalSetup;
    exports.TemplateHint = TemplateHint;
    exports.templateHintInternalSetup = templateHintInternalSetup;
    exports.Hidden = Hidden;
    exports.hiddenInternalSetup = hiddenInternalSetup;
    exports.Sortable = Sortable;
    exports.sortableInternalSetup = sortableInternalSetup;
    exports.Readonly = Readonly;
    exports.readonlyInternalSetup = readonlyInternalSetup;
    exports.FormatPipe = FormatPipe;
    exports.formatInternalSetup = formatInternalSetup;
    exports.FormValidatorFromJsonService = FormValidatorFromJsonService;
    exports.FormValidatorService = FormValidatorService;
    exports.DataGridPaginationComponent = DataGridPaginationComponent;
    exports.Direction = Direction;
    exports.DataGridModel = DataGridModel;
    exports.DataGridComponent = DataGridComponent;
    exports.FormatDataPipe = FormatDataPipe;
    exports.EditorComponent = EditorComponent;
    exports.AutoFormComponent = AutoFormComponent;
    exports.TreeViewComponent = TreeViewComponent;
    exports.TreeViewNodeComponent = TreeViewNodeComponent;
    exports.TreeNodeState = TreeNodeState;
    exports.TreeNodeOptions = TreeNodeOptions;
    exports.TreeNodeModel = TreeNodeModel;
    exports.TextTreeNodeModel = TextTreeNodeModel;
    exports.TreeNodeComponentModel = TreeNodeComponentModel;
    exports.SvogvModule = SvogvModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=svogv.umd.js.map