/**
 * The Sortable decorator.
 *
 * The @see `DataGrid` does not sort columns for properties tagged with `@Sortable(false)`.
 * The default is that all columsn are sortable. Either avoid this decorator or use `@Sortable(true)`.
 * Additionally, if the decorator is provided, you can add a sort function callback as second parameter.
 *
 * @param canSort       Suppress or allow sorting.
 * @param sortCallback  An optional callback that provides a sort instruction. If omitted, `Array.prototype.sort` is being used.
 */
export declare function Sortable(canSort: boolean, sortCallback?: (a: any, b: any) => 1 | -1 | 0): (target: Object, property: string | symbol) => void;
export declare function sortableInternalSetup(target: any, key: string, canSort: boolean, sortCallback: Function): void;
