import { FormGroup } from '@angular/forms';
import { FormValidatorService } from './formvalidator.service';
import { FormValidatorModel } from './formvalidator.model';
/**
 * A JSON object can describe the form. That way you can create the form and their behavior on the server.
 *
 * The form's description is an array, where each element describes one field:
 *
 * ```
 * [
 *   "fieldname": {
 *       "display": {
 *          "name": string;
 *          "order": number;
 *          "description": string
 *       },
 *       "displaygroup": {
 *          "name": string;
 *          "order": number;
 *          "description": string
 *       },
 *       "format": {
 *          "pipeName": any;
 *          "pipeParams": any[]
 *       }
 *       // ...
 *    }
 * ]
 * ```
 *
 * The properties are the same as the decorators. @see FormValidatorModel for the describing type.
 *
 */
export declare class FormValidatorFromJsonService {
    private formValidatorService;
    constructor(formValidatorService: FormValidatorService);
    build(json: FormValidatorModel): FormGroup;
}
