import { OnInit } from '@angular/core';
import { FormGroup } from '@angular/forms';
/**
 * This component creates a complete editor out of a viewmodel.
 * It creates one field for each property not decorated with @Hidden.
 *
 */
export declare class AutoFormComponent implements OnInit {
    /**
     * A reference to the form. Required.
     */
    formGroup: FormGroup;
    /**
     * Ungrouped element will appear at the end, after all groupes.
     * If there are no groups this will be ignored. Optional.
     */
    ungroupedAfter: boolean;
    editors: Array<{
        key: number;
        editor: string;
    }>;
    groups: Array<{
        key: number;
        name: string;
        desc: string;
        editors: Array<{
            key: number;
            editor: string;
        }>;
    }>;
    constructor();
    ngOnInit(): void;
    grouped(): boolean;
}
