import { EventEmitter } from '@angular/core';
import * as tree from './treenodeoptions.model';
import { TreeNodeBaseModel } from './treenodebase.model';
/**
 * The base class for tree nodes.
 */
export declare class TreeNodeModel implements TreeNodeBaseModel {
    /**
     * Control appearance
     */
    options: tree.TreeNodeOptions;
    /**
     * structure
     */
    parent: TreeNodeModel;
    /**
     * Subsequent nodes.
     */
    children: TreeNodeModel[];
    /**
     * An identifier.
     */
    name: string;
    /**
     * Field id
     */
    id: number;
    /**
     * behavior
     */
    stateChange: EventEmitter<tree.TreeNodeState>;
    private _state;
    constructor(options?: tree.TreeNodeOptions, nodes?: TreeNodeModel | TreeNodeModel[]);
    readonly path: Array<TreeNodeModel>;
    hasDirectAncestor(node: TreeNodeBaseModel): boolean;
    readonly hasChildren: boolean;
    add(nodes: TreeNodeModel | TreeNodeModel[]): void;
    remove(node: TreeNodeModel): boolean;
    state: tree.TreeNodeState;
    readonly stateIsExpandend: boolean;
    readonly stateIsDisabled: boolean;
    readonly stateIsSelected: boolean;
    readonly stateIsChecked: boolean;
}
