import { EventEmitter } from '@angular/core';
import { TreeNodeModel } from './models';
/**
 * A treeview that can handle @see TreeNodeModel objects that create text, checkboxes, or highlights.
 * A node can have an icon. The icons are based on FontAwesome's css classes.
 */
export declare class TreeViewComponent {
    nodes: TreeNodeModel;
    nodeClick: EventEmitter<TreeNodeModel>;
    checkChanged: EventEmitter<TreeNodeModel>;
    selectedChanged: EventEmitter<TreeNodeModel>;
    collapseChanged: EventEmitter<TreeNodeModel>;
    constructor();
    onNodeClick(node: TreeNodeModel): void;
    onCheckChanged(node: TreeNodeModel): void;
    onSelectedChanged(node: TreeNodeModel): void;
    onCollapseChanged(node: TreeNodeModel): void;
}
